# $Header: /home/auspex/h/bair/phelps/spine/tkman/RCS/tkman.tcl,v 1.147 1995/11/02 21:08:46 phelps Exp phelps $

#
# Bird?  Plane?  TkMan!  (TkPerson?)
#
#   by Tom Phelps (phelps@cs.Berkeley.EDU)
#      March 24-25, 1993
#
#   Copyright (c) 1993-1995  T. A. Phelps
#
# 1993
# 24-Mar  hard stuff working
# 25      easy stuff finished up, including documentation
# 29      wrote Makefile and otherwise prepared for distribution
# 31      changed incremental searching
#  1-Apr  posted to comp.lang.tcl (698 lines, including instructions)
#  2      more portable version posted
#         browsers `send' to `manShowManFound', sink manual section
#  4      SEE ALSO links filter, unpacks compressed pages (both inspired by Paul Raines)
#  5      manX.[zZ] directories, whatis found in text
#  6      workaround for bind bug, sunken text (both Dan Schenck)
#         "Searching for ..." message
#  7      print: now meta-click, works with compressed ones
#         fixed bind problems
#         can type in, e.g., print.3v and print.3s; distinction saved in history
#         .so links work (thanks Dave Lemke)--
#            but don't do this with compressed pages (which HPs don't)
#         various portability/system admin (suggested by model bug reporter Lars Huttar)
#  8      memory pipe replaces tmp file
# 10      Emacs-like point and mark
#         sections loaded on demand (suggested by Lars Huttar)
#         user additions preserved in ~/.tkman 
#         quick view of first n lines
# 11      >1000 lines
#         wait cursor, tkinfo shares window with TkMan
# 12      option to preload or not, instant show update moved to bs2tk
# 13      restricted search of paths in MANPATH (anthony baxter)
# 14      case sensitivity switches to searches (anthony baxter)
# 15      tbl, eqn handled (Mark McIntosh)
# 17      incremental searching made more like Emacs, flush volume cache
#         (both suggested by Robert Wilensky)
# 19      fixed handling of compressed pages, section re-viewing much faster
# 20      solution to multiple, identically-named man pages in different directories,
#            at the expense of volume load on demand
# 25      different way to deal with multiples
# 27      hack around Tk text's wordend limitation
# 29      compressed database hack around
#         v1.3.3 released
# 30      dups menu hangs around, different hack around for compressed database
#  2-May  faster startup with database (big thanks to Frank Delahoyde)
#         SuperMan, of dubious value since it's so slow (suggested by Larry Virden)
#  5      demo to UCB Tcl/Tk users
#  7      (none) and (n/a) shown when pulldowns empty (Steve Smoot)
# 14      manTextOpen, manTextClose, manSectButt
#         documented: scan, pipe capability of apropos
#         apropos responsive to selected directory switches (Robert Wilensky)
# 15      more generous focus hits (Steve Smoot), tab moves focus
# 18      v1.3.4 released
# 19      v1.3.5 released (fixed bug which affected first-time users)
#         default fonts changed from pixel specification to point size (Donn Cave)
# 29      man page name searching case insensitive--search time 3->4 seconds
#         (Wayne A. Christopher)
#  1-Jun  multiple instantiations
#  2      output menu for multiple instantiations
#         changed default font to New Century Schoolbook so underscores show up
#  4      switch all man paths on or off (David Taubman)
#  7      . and .. to ~ and / (John Hagerman)
# 25      support for people with only cat directories (6 characters from Mike Beasley)
#         v1.4 released
# 28      deleted "focus $w.show" at very end of proc TkMan.  otherwise if start up
#             iconified, then deiconify before done with init, text window doesn't show up.
#             It's the focus problem again.  (David Svoboda)
# 29      "update, don't quit" (Gordon Lack & Lord Wodehouse)
#  1-Jul  lengthier criteria for picking which to show from list of matches
#         (Michael Moore and Kwo-Long Lai)
# 14      option not to move change bars, apropos filter in variable (both Warren Jessop)
# 18      manKeyNav's key bindings to variables (David Sibley; thanks Wayne Christopher)
#         moved Paths, added `All' to Volumes (Neal McBurnett, friend of Scott Schwartz)
#         option to save nroff-formatted version (Warren Jessop)
# 24      margins around text box (colleague of Gordon Lack)
# 26      character to indicate popup menu (too bulky and unaesthetic, though)
# 27      keep list of man pages with dots--startup takes a couple more seconds (Warren Jessop)
#  4-Aug  check to see if man page source is older than nroff (Warren Jessop)
#         C-s C-s retrieves last search pattern, as in Emacs
#  5      multiple instantiations share menu windows--sabotaged by new requirement in Tk 3.3
#  6      each instance gets own set of variables
#         `|command' syntax for arbitrary text-generating command,
#         `<file' syntax for reading raw file
#         uses SearchBox mega widget
#  8      file name completion (if had fast database could do
#            man page name completion and spelling correction)
# 11      user annotations (first cool new idea since March!)
#            (could have set of different annotations but would that be useful?)
#            (automatically jump to first highlight?)
# 17      mandesc-like directory dance hall (clamored for by Oyvind Yrke)
#         >2000 lines, 70K characters, despite kicking generally useful code into taputils.tcl
#         decision: don't integrate tkinfo (it could use the searchbox megawidget, though)
# 20      changes to tkmandesc (Oyvind Yrke)
# 21      SGI support worked out (Paul Raines)
# 13-Sep  greater control of ordering of added (pseudo) volumes (Paul Raines)
# 15      submitted to comp.sources.testers
#         >80K characters
# 20      fixed printing of .so pages (Larry Virden)
# 21      various parts of ui disabled for different text box content types
# 28      1.5 review version available via comp.sources.testers
#  7-Oct  iconposition, -nosave, tkmangeometry (Chris Siebenmann)
# 12      reviews received from comp.sources.testers
#         C-d/C-m hot keys (Kwo-Long Lai)
#         variety of small changes suggested by the anonymous reviewers
#            removed gzip requirement for H-P
#            if main window owns X selection, zap it before showing another page
# 13      taking advantage of bs2tk's new reverse compile, do this for cat page printouts
#         show hot spot on a single click (many, Robert Wilensky first)
#         more small changes suggested by reviewers
#            killing TkMan with window manager's kill removes process
# 21      >90K characters
# 24      highlights for symbolic links resolved to physical file
#  2-Nov  1.5 released for Tcl 7.0/Tk 3.3
# 24-Dec  TKMAN environment variable sets usual options
#
# 1994
#  1-Jan  support for LANG environment variable (Yasuro Kawata)
# 21      support for saving to H-P's cat.Z (w/o .Z/.gz/.z suffix)
# 28      fixed deep weirdness, write protected home directory bugs (Dave Glowacki)
#  1-Apr  first anniversary
# 12-May  list of all man pages with highlights (Steven S. Dick)
# 23      help page maintained in HTML, compiled to Tk text and [tn]roff
#         (can zap linebreaks so get good linebreaking on all screen sizes!)
#  5-Jun  would like to use idiom like: menubutton -menu [set m [menu $w.x.m]]
#         but have to do this: set m $w.x.m; menubutton -menu $m; menu $m
#  6-Aug  experiment in moving database to Glimpse
# 10      compressed list of all man page names works great:
#         < 40K in size (with gzip), quick to search (preserves pattern matching),
#         since kept on disk reduces startup time and memory image
#         runs off tkmandesc orderings so can still do wild additions, section dumps efficient
# 24      search within virtual sections too
#         finds names with dots (again)
# 26      incremental search highlights match
#         try to find needed binaries beforehand, abort if can't (Keith Vetter among others)
#  1-Sep  support for weird /etc/man.conf (Shannon Jaeger)
#         dynamically change font dpi
#  4      handle .so links to compressed pages (grr)
#  6      validity checks on components of MANPATH
#  9      hookup with Glimpse for fulltext search only (& optionally)
# 12      1.6beta testing
# 16      glimpse AND apropos, both now dumping results into a pseudo volume
#         Perl's out, only Tcl for formatting volumes... sigh
# 17      automatically rebuild database every month
# 22      if current mandir != mandir used to build database, automatically rebuild it
# 26      automatically rebuild database if change in MANPATH or tkmandesc commands
# 27      -rebuildandquit option (Dietmar Theobald)
#         instead of monthly rebuilds, simply check dates of mandirs--
#            it takes a noticable amount of time, but not excessively long (Dietmar Theobald)
# 29      Volume lists dynamically created, once again controlled by Paths (push from Kevin L. Short)
#         database validity check information moved into .tkmandatabase
# 30-Sep  1.6gamma testing
#  7-Oct  use simple priority number to choose better the right manual page
#            (why didn't I think of this before?)
# 31-Oct  list of new/changed manual pages, if any, as pseudovolume
#         when looking at header&footer, show date of file also
#  7-Nov  support for keeping Solaris 1, 1b, 1c, ... volumes separate (Will C Lauer)
# 10&11   preferences panels (code now >100K characters, >3000 lines)
# 21      Support for proposed Linux FSSTND /var/catman
# 23      deep-six the problematic mandir variable and suck up all unique
#             names in manN*/* and catN*/* assuming they're in manN*/*
#             => takes to long to build database
# 25      abolished mandir variable (which so many didn't set correctly)
#             if no manN, check for catN automatically.  lose on stray cats, though
# 29      manDescAdd also makes that directory available to Glimpse
#         Tcl code indention: spaces => tabs, saving 9K
#  7-Dec  1.6delta testing
#  8      IBM AIX support: first need to convert InfoExplorer files to /usr/man/cat*
#            can't parse pages (so don't), so lose on Sections, Links.  but everything else OK
#  9      restored SGI support (oops!)
# 15      bad variable values in old save file automatically updated (Martin Forssen & Greg McFarlane)
# 17      "(none)"'s changed to -state disabled's (don't have someone try it and fail)
# 20      pulldown menus shrink as necessary to fit on screen, if possible (Marty Leisner)
# 22      Winter Solstice:  1.6 released for use with RosettaMan + new database
#         (100th RCS revision, 3628 lines)
# 24      updated for Tcl 7.4/Tk 4.0
# 29      new idiom for menubuttons + menus
#
# 1995
#  1-Jan  time to display page once found cut by more than a third
#            by (1) changing while {[gets $fid line]!=1} {eval $line}
#                   to       while {![eof $fid]} {eval [gets $fid]}
#           and (2) hacking tkText.c to accept multiple (text,tags+mark) pairs
# 20      right pseudosection set for Shortcuts
# 24-Mar  tweaks to Glimpse, site-wide installation (John Talintyre)
# 25      changes for Tk 4.0b3: tk colormodel, -nocase (grr, no easy marks for text widget)
#         1.7b1 released for Tcl 7.4b3/Tk 4.0b3
# 26-Apr  chmod a+r for Glimpse indexes (except those in one's home directory) (Jim Ingham)
# 29-Jun  1.7b2 released for Tcl 7.4b4/Tk 4.0b4
# 30      1.7b3 released to fix some egregious bug or something
# 21-Jul  1.7 released for Tcl 7.4/Tk 4.0
#         Preferences' Defaults button applies to current panel only (Don Libes)
# 26      1.7.1 released, advertised widely
#  1-Aug  miscellaneous small fixes, columns for apropos
#         >4000 lines (happened sometime earlier)
#         1.7.2 released to fix problem in passing command line options
#  9      added manDescSGI to place catman directories (Scott Nelson)
#            into user-added volumes
#            according to user-specified patterns
#            Is this a final solution to the SGI issue?
# 11      only reset gui if something changed in Preferences
#         1.7.3b2 advertised to SGI users
# 18      option to present subvolumes as submenus under Volumes (original version by Nigel Wade)
#         1.7.3 released
# 24      special case for `whatis' file check on dumb BSDI (John Carroll)
# 10-Oct  1.7.4 released
#  2-Nov  1.7.5 released

# add more anchors to help pages and add context help?
#	maybe link to clicking on label in Preferences...
# option to title icon to current man page?
# put short UNIX names in preferences(?) => belongs in Makefile, where it is now
# in addition to history list, back and forward buttons (Robert Withrow)

# break out changes list above into separate CHANGELOG file?
# if empty search string set to man page name (Ian Darwin)

# split screen with slider for names and page contents?
# out of the box support for SGI/System V catman?

### coming attractions
# show random icon each time?  Rei's first time.
# more efficient Glimpse searching?
# inlined icon choices?
# option for TkMan autoraise or leave that to window manager?

# should rewrite Preferences so that entries are specified descriptively
# and a general interpretation proc builds the gui



###
### proc's (only--no variables, proc calls)
###

wm withdraw .; update idletasks
option add *Menubutton.relief raised
option add *padX 2
option add *padY 2
option add *Button.padX 2
option add *Button.padY 2
option add *Menubutton.padX 2
option add *Menubutton.padY 2
option add *Radiobutton.padX 2
option add *Radiobutton.padY 2


#--------------------------------------------------
#
# TkMan -- make the gui
#
#--------------------------------------------------

proc TkMan {} {
	global man manx mani env winout

	# determine instance name
	if {$manx(uid)==1} {
		set dup 0
		# .man is guaranteed to exist
		set w .man
	} else {
		set dup 1
		set w .man$manx(uid)
		toplevel $w -class TkMan
	}

	bind $w <Unmap> "if \$man(updateicon) { wm iconname $w \$manx(name$w) }"

	set t $w.show; set wi $w.info

	# initialize per-instance variables
	set manx(man$w) ""
	set manx(manfull$w) ""
	set manx(catfull$w) ""
	set manx(name$w) ""
	set manx(num$w) ""
	set manx(cursect$w) 1
	set manx(lastvol$w) 1
	set winout(lastMessage$wi) ""
	set manx(hv$w) [set manx(oldmode$w) [set manx(mode$w) help]]


	# make the gui
	wm minsize $w 200 200
	# temporarily, to get around twm bug (yuck!)
	wm iconname $w "TkMan"

	if {!$dup} {
		wm title $w $manx(title)
		wm geometry $w $manx(geom)
		# aborts without saving .tkman
		wm protocol $w WM_DELETE_WINDOW {exit 0}

		if {$manx(iconify)} {
			wm iconify $w
			update idletasks
		}
	} else {
		wm title $w "$manx(title) - #$manx(uid)"
		wm geometry $w [lfirst [split $manx(geom) "+-"]]
#		wm group $w .man
	}


	### information bar
	label $wi -anchor w
#	label $w.volnow -anchor e

	### man or section
	frame $w.kind
	button $w.man -text "man" -command "manShowMan \$manx(typein$w) {} $w"
	button $w.apropos -text "apropos" -command "manApropos \$manx(typein$w) $w"
	if {$man(glimpse)!=""} {button $w.glimpse -text "glimpse" -command "manGlimpse \$manx(typein$w) $w"}
	entry $w.mantypein -relief sunken -textvariable manx(typein$w) -width 25
	# should make this a Preference
	bind Entry <Key-Delete> [bind Entry <Control-Key-h>]
	bind Entry <Control-KeyPress-w> {%W delete 0 end}
	bind $w.mantypein <KeyPress-Return> "$w.man invoke"
	# ha! meta information
	bind $w.mantypein <Shift-KeyPress-Return> "$w.apropos invoke"
	if {$man(glimpse)!=""} {
		foreach m {"Meta" "Alt"} {
			bind $w.mantypein <$m-KeyPress-Return> "$w.glimpse invoke"
		}
	}
	menubutton [set mb $w.dups] -text "\337" -menu [set m $mb.m]; menu $m
# -font $font(guisymbol)

	pack $w.man -in $w.kind -side left -padx 2 -anchor e
	pack $w.apropos -in $w.kind -side left -padx 3
	if {$man(glimpse)!=""} { pack $w.glimpse -in $w.kind -side left -padx 3	}
	pack $w.mantypein -fill x -expand yes -in $w.kind -side left -ipadx 5 -anchor w

	menubutton [set mb $w.paths] -text "Paths" -menu [set m $mb.m]; menu $m
	if {[llength $manx(paths)]>2} {
		$m add command -label "All Paths On" -command {
			foreach i $manx(paths) {set man($i) 1}
			manResetEnv
		}
		$m add command -label "All Paths Off" -command {
			foreach i $manx(paths) {set man($i) 0}
			manResetEnv
		}
		$m add command -label "Save Paths Selections" -command {
			set manx(pathstat) ""
			foreach i $manx(paths) {lappend manx(pathstat) $man($i)}
		}
		$m add command -label "Restore Paths Selections" -command {
			set ctr 0
			foreach i $manx(paths) {set man($i) [lindex $manx(pathstat) $ctr]; incr ctr}
			manResetEnv
		}
		$m add separator
	}
	foreach i $manx(paths) {
		$m add checkbutton -label $i -variable man($i) -command {manResetEnv}
	}
	manMenuFit $m


	menubutton [set mb $w.vols] -text "Volumes" -menu [set m $mb.m]; menu $m -tearoff no

	pack [frame $w.filler] -in $w.kind -side left -fill x -expand yes
	pack $w.vols $w.paths -in $w.kind -side left -padx 4


	### navigation
	frame $w.nav
	menubutton [set mb $w.sections] -text "Sections" -menu [set m $mb.m]; menu $m -tearoff no
	menubutton [set mb $w.links] -text "Links" -menu [set m $mb.m]; menu $m -tearoff no

	frame $w.hlf
	menubutton [set mb $w.high] -text "Highlights" -menu [set m $mb.m]; menu $m -tearoff no
	button $w.hadd -text "+" -padx 4 -command "
		if \[llength \[$t tag nextrange sel 1.0\]\]==0 {
			winstderr $wi {Select a range of characters to highlight.}
			return
		}
		set mani(high,form) {}
		$t tag add highlight sel.first sel.last
		selection clear $t
		manHighlights $w
	"
	button $w.hsub -text "-" -padx 4 -command "
		if \[llength \[$t tag nextrange sel 1.0\]\]==0 {
			winstderr $wi {Select a range of highlighted characters to unhighlight.}
			return
		}
		$t tag remove highlight sel.first sel.last
		set mani(high,form) {}
		selection clear $t
		manHighlights $w
	"
	pack $w.high $w.hadd $w.hsub -in $w.hlf -side left -padx 1


	frame $w.scf
	menubutton [set mb $w.shortcuts] -text "Shortcuts" -menu [set m $mb.m]; menu $m -tearoff no
	button $w.sadd -text "+" -padx 4 -command "manShortcuts $w add"
	button $w.ssub -text "-" -padx 4 -command "manShortcuts $w sub"
	pack $w.shortcuts $w.sadd $w.ssub -in $w.scf -side left -padx 1
	manShortcuts $w init


	menubutton [set mb $w.history] -text "History" -menu [set m $mb.m] -state disabled; menu $m -tearoff no
	set manx(history$w) ""
#	$m add command -label "(none)"


	menubutton [set mb $w.output] -text "Output" -menu [set m $mb.m]; menu $m -tearoff no
	set manx(out$w) $w


	### commands not used as frequently
	menubutton [set mb $w.occ] -text "Occasionals" -menu [set m $mb.m]; menu $m
	$m add command -label "Help" -command "manHelp $w"
	$m add command -label "Print" -command "manPrint $w"
	$m add command -label "Instantiate New View" -command manInstantiate
	$m add command -label "Rebuild Database" -command "manReadSects $w 1 {Rebuilding database ...}" \
		-state [expr [file writable [file dirname $manx(database)]]?"normal":"disabled"]

# used to have entry to rebuild only if existed at least one writable directory
#	if {$manx(glimpseindex)!=""} {
	if {$man(glimpseindex)!=""} {
		$m add command -label "Rebuild Glimpse Database" -command "manGlimpseIndex $w"
	}
	$m add cascade -label "Incremental Search Case Sensitive" -menu [set m2 $m.m2]
		menu $m2 -tearoff no
		$m2 add radiobutton -label "yes" -variable man(incr,case) -value 1
		$m2 add radiobutton -label "no" -variable man(incr,case) -value 0
		$m2 add radiobutton -label "iff upper" -variable man(incr,case) -value -1
	$m add cascade -label "Regexp Search Case Sensitive" -menu [set m2 $m.m3]
		menu $m2 -tearoff no
		$m2 add radiobutton -label "yes" -variable man(regexp,case) -value 1
		$m2 add radiobutton -label "no" -variable man(regexp,case) -value 0
		$m2 add radiobutton -label "iff upper" -variable man(regexp,case) -value -1
	$m add checkbutton -label "Changebars on Left" -variable man(changeleft) -onvalue "-c" -offvalue ""
	$m add command -label "Preferences..." -command manPreferences
	$m add command -label "Checkpoint state to .tkman" \
		 -command "manSave; winstdout $wi {[bolg $manx(startup) ~] updated}"
	$m add separator
	$m add command -label "Quit, don't update .tkman" -command "exit 0"
#	$m add command -label "Quit" -accelerator M-q \
#		-command "manSave"


	foreach i {sections hlf links history scf occ} {pack $w.$i -in $w.nav -side left}
	foreach i {hlf history occ} {pack configure $w.$i -padx 6}
	pack configure $w.links -expand yes -anchor e
	pack configure $w.scf -expand yes -anchor w


	### view box
	frame $w.vf
	text $t \
#-font $man(currentfont) \
		-relief sunken -borderwidth 2 -padx $man(textboxmargin) -pady $man(textboxmargin) \
		-yscrollcommand "$w.v set" -exportselection yes -wrap word -cursor $manx(cursor) \
		-height 10 -width 5 -insertwidth 0
	foreach b {Double-Button-1 Shift-Button-1} { bind Text <$b> {} }
	$t tag configure apropos -wrap word

	# bind letters to jump to that part of list
	bind $t <Any-KeyPress> "if \[manKeyNav $w \[key_state2mnemon %s\] %K\] break"
	bind $t <Control-KeyPress-d> "manShowSection $w \$manx(lastvol$w)"
	bind $t <Control-KeyPress-m> "manShowMan \$manx(lastman) {} $w"
	scrollbar $w.v -orient vertical -command "$t yview"
	pack $w.v -in $w.vf -side $man(scrollbarside) -fill y
	pack $t -in $w.vf -side $man(scrollbarside) -fill both -expand yes

	bind $t <ButtonRelease-1> "
#puts stderr {%W ButtonRelease-1}
		if !\$tkPriv(mouseMoved) {
			manHotSpot show %W @%x,%y
			catch {if {\[string trim \[set tmp \[manHotSpot get %W @%x,%y\]\]\]!={}} {set manx(typein$w) \$tmp}}
		}
	"

	# Shift-double to instantiate new viewer for page
#	bind $t <Shift-ButtonRelease-1> {
#puts stderr "%W Shift-ButtonRelease-1"
#		eval [bind %W <ButtonRelease-1>]
#	}
	bind $t <Shift-Double-ButtonRelease-1> {
#puts stderr {%W Shift-Double-ButtonRelease-1}
		if !$tkPriv(mouseMoved) {catch {
			if {[string trim [set tmp [manHotSpot get %W @%x,%y]]]!=""} {
				set manx(shift) 1; manShowMan $tmp
			}}
		}
	}
	# shift on various menus, buttons instantiates new viewer too
	foreach b [list $w.man $w.apropos] {
		bind $b <Shift-ButtonRelease-1> {set manx(shift) 1 }
	}
	if {$man(glimpse)!=""} {bind $w.glimpse <Shift-ButtonRelease-1> {set manx(shift) 1} }
	foreach mb [list $w.vols $w.links $w.history $w.shortcuts] {
		bind $mb.m <Shift-ButtonRelease-1> {set manx(shift) 1 }
	}

	# Alt-double to assume pathname, show as text
	bind $t <Alt-Double-ButtonRelease-1> "
#puts stderr {%W Meta-ButtonRelease-1}
		if !\$tkPriv(mouseMoved) {
			if {\[set tmp \[string trimright \[manHotSpot get %W @%x,%y\] {.;,!?}\]\]!={}} {manShowText <\$tmp \$w}
#\$manx(typein$w) $w
#
		}
	"


	### search (uses searchbox--wow, code reuse!)
	frame $w.search
	button $w.search.s -text "Search" -command "
		set manx(search,cnt$w) \[searchboxSearch \$manx(search,string$w) 1 \$man(regexp,case) search $t $wi $w.search.cnt\]
	"
	button $w.search.n -text "Next" \
		-command "searchboxNext search $t $wi"
	label $w.search.cnt
	entry $w.search.t -relief sunken -textvariable manx(search,string$w)
	set manx(search,cnt$w) 0
	set manx(search,oldstring$w) ""
	bind $w.search.t <KeyPress-Return> "
		if {\$manx(search,oldstring$w)!=\$manx(search,string$w) || !\$manx(search,cnt$w)} {
			set manx(search,oldstring$w) \$manx(search,string$w)
			$w.search.s invoke
		} else {$w.search.n invoke}"
	pack $w.search.s -side left
	pack $w.search.n -side left -padx 6
	pack $w.search.t -side left -fill x -expand yes -ipadx 10 -anchor w
	pack $w.search.cnt -side left

#	bind $t <KeyPress-slash> "focus $w.search.t"

	### font
	# mostly mono (Mozart?)
	checkbutton $w.mono -text "Mono" -variable man(currentfont) \
# -onvalue and -offvalue set elsewhere
#		-onvalue $font(mono) -offvalue $font(pro) \
#		-font $font(guimono) \
		-command "
			$t configure -font \$man(currentfont)
#			$t tag configure italics -underline \
#				\[expr 1-\[lfifth \[$t tag configure italics -underline\]\]\]
		"

	### quit
	button $w.quit -text "Quit" -command "manSave; exit 0" -padx 4
	if {!$manx(quit)} {$w.quit configure -command "exit 0"}
	if {$dup} {$w.quit configure -text "Close" -command "destroy $w; incr manx(outcnt) -1; manOutput"}
	bind all <Meta-KeyPress-q> "$w.quit invoke"

	pack $w.mono -in $w.search -side left -padx 3 -anchor e
	pack $w.quit -in $w.search -side left -padx 3


	pack $wi $w.kind -fill x -pady 4
	pack $w.nav -fill x -pady 6
	pack $w.vf -fill both -expand yes
	pack $w.search -fill x -pady 6


	# generous hit regions, tab between
	foreach i {info kind nav} {bind $w.$i <Enter> "focus $w.mantypein"}
	foreach i {vf show v} {bind $w.$i <Enter> "focus $t"}
	bind $w.search <Enter> "focus $w.search.t"
	tabgroup $w.mantypein $t $w.search.t
	foreach i {mantypein show search.t} {
		foreach k {KeyPress-Escape Control-KeyPress-g} {
			bind $w.$i <$k> {+ set STOP 1 }
		}
	}
	# fixups
	foreach k {KeyPress-Escape Control-KeyPress-g} {
		bind $t <$k> "+ if \[manKeyNav $w \[key_state2mnemon %s\] %K\] break"
	}
	bind $w.mantypein <KeyPress-Escape> "+
		if \[regexp {^\[<|.~/$\]} \$manx(typein$w)\] {manFilecomplete $w}
	"

	manMakeVolList $w
	manPreferencesSetMain $w

	manHelp $w
#	update idletasks

	return $w
}


proc manMakeVolList {w} {
	global man manx

	if ![winfo exists $w.vols] return
	set m $w.vols.m
	destroy $m
	menu $m -tearoff no
	#delete 0 last

	$m add command -label "Last volume viewed" -accelerator "C-d" -state disabled \
		-command "manShowSection $w \$manx(lastvol$w)"
	$m add separator

	set iapropos [lsearch -exact $manx(manList) "apropos"]

	set ctr 0
	foreach i $manx(manList) {

		set menu $m; set label "($i) [lindex $manx(manTitleList) $ctr]"

		if $man(subvols) {
			set l1 [string range $i 0 0]
			set p [lsearch -exact $manx(manList) $l1]
			set c [lsearch -glob $manx(manList) "$l1?*"]; if {$c>=$iapropos} {set c -1}

			if {$p!=-1 && $c!=-1} {
				# part of a group => add entry to cascade menu
				set menu $m.$p
				if {$ctr==$p} {set label "general"}

				# if that cascade menu doesn't exist yet, create it now
				# (so submenus need not precede their root)
				if ![winfo exists $menu] {
					menu $menu -tearoff no
					$m add cascade -label "($i) [lindex $manx(manTitleList) $p]" -menu $menu
				}
			}
		}

		# everybody gets added somewhere, under some name
		$menu add command -label $label -command "manShowSection $w $i"
		incr ctr
	}

	manMenuFit $m
}



#--------------------------------------------------
#
# Shortcuts
#
#--------------------------------------------------

proc manShortcuts {w cmd} {
	global man manx

	set me "$manx(name$w).$manx(cursect$w)"
#puts "$manx(man$w) => $manx(name$w).$manx(cursect$w)"

	set modeok [lmatch {man txt} $manx(mode$w)]
	if {$cmd!="init" && (!$modeok || $manx(man$w)=="")} return

	set present [expr [lsearch -exact $man(shortcuts) $me]!=-1]
	if {$cmd=="add" && !$present} {lappend man(shortcuts) $me} \
	elseif {$cmd=="sub" && $present} {set man(shortcuts) [lfilter $me $man(shortcuts)]}

	# for each instantiation, update shortcuts list
	set m [set mb $w.shortcuts].m
	foreach w [lmatches ".man*" [winfo children .]] {
		$m delete 0 last
		set len [llength $man(shortcuts)]
		if {$len} {
			foreach i $man(shortcuts) {
				if {![regexp {^[<|]} $i]} {
					#  usual man page
					if {[regexp $man(zregexp) $i]} {set i [file rootname $i]}
					if {[lsearch $manx(mandot) $i]>-1} {set name $i} {set name [file rootname $i]}
				} else {set name $i}
#				set name [file rootname $i]} {set name $i}
				$m add command -label $name -command "manShowMan [list $i] {} $w"
			}
		}

		configurestate $mb $len
		manShortcutsStatus $w
		manMenuFit $m
	}
}


proc manShortcutsStatus {w} {
	global man manx

	set me $manx(name$w).$manx(cursect$w)

	set modeok [lmatch {man txt} $manx(mode$w)]
	set present [expr [lsearch -exact $man(shortcuts) $me]!=-1]
	configurestate $w.sadd [expr $modeok&&!$present]
	configurestate $w.ssub [expr $modeok&&$present]
}


# compensate for Tk's nonalphnum-bounded wordstart and wordend
# should have companions to word{start,end} that are bounded by whitespace, not nonalpha
# (in this case analysis too complex for an extended wordstart)

proc manHotSpot {cmd t xy} {
	global man

	set manchars {[ a-z0-9_.~/$+()-]}

	# click again in hot spot without time considerations
#	if {!catch{$t index hot.first} && [$t compare hot.first <= $xy] && [$t compare $xy >= hot.last]} {
#		set cmd get
#	}

	# act on command
	if {$cmd=="get"} {
		set hot [expr {[$t tag ranges hot]!=""?[$t get hot.first hot.last]:""}]
		return $hot
	}

	# else $cmd=="show"
	$t tag remove hot 1.0 end

	scan [$t index $xy] "%d.%d" line char
	scan [$t index "$line.$char lineend"] "%d.%d" bozo lineend

	# special cases when clicking on parentheses
	set c [$t get $line.$char]
	if {$c=="("} {
		if {$char>0 && [$t get $line.$char-1c]!=" "} {incr char -1} {incr char}
	} elseif {$c==")"} {
		if {$char>0} {incr char -1}
	}


	set lparen 0; set rparen 0
	# single space between name and parenthesized volume ok (apropos puts this in?)
	set fspace 0

	# gobble characters forwards
	for {set cn $char} {$cn<=$lineend && [regexp -nocase $manchars [set c [$t get $line.$cn]]]} {incr cn} {
		if {$c=="("} {
			if {!$lparen} {set lparen $cn} else break
		} elseif {$c==")"} {
			if {!$rparen} {set rparen $cn; incr cn}
			break
		} elseif {$c==" "} {
			if {!$lparen && !$fspace && $cn<$lineend && [$t get $line.$cn+1c]=="("} {set fspace 1} else break
		}
	}
	incr cn -1

	# gobble characters backwards
	for {set c0 $char} {$c0>=0 && [regexp -nocase $manchars [set c [$t get $line.$c0]]]} {incr c0 -1} {
		if {$c=="("} {
			if {!$lparen} {set lparen $c0} else break
		} elseif {$c==")"} {
			break
		} elseif {$c==" "} {
			if {$lparen==[expr $c0+1] && !$fspace} {set fspace 1} else break
		}
	}
	incr c0

	# adjust if parentheses unbalanced
	if {!$lparen^!$rparen} {
		if {$lparen} {
			if {$char>$lparen} {set c0 [expr $lparen+1]} {set cn [expr $lparen-1]}
			set lparen 0
		} else {
			# trim off right paren
			incr cn -1
		}

	# check for valid section number
	} elseif {$lparen && [lsearch $man(manList) [$t get $line.$lparen+1c]]==-1} {
		if {$char>$lparen} {set c0 [expr $lparen+1]} {set cn [expr $lparen-1]}
		set lparen 0

	# nothing between parentheses
	} elseif {$lparen==[expr $rparen-1] && $lparen>0} {
		set cn [expr $lparen-1]

	# if have good parens, can't start with a "/"
	} elseif {$lparen && $rparen && [$t get $line.$c0]=="/"} {
		incr c0
	} 

	# clean up sides
	while {$c0>0 && [lsearch {" "} [$t get $line.$c0]]>=0} {incr c0}
	while {$cn>$c0 && [lsearch {. -} [$t get $line.$cn]]>=0} {incr cn -1}


	$t tag add hot $line.$c0 $line.$cn+1c
}


proc manInstantiate {} {
	global manx

	incr manx(uid)
	incr manx(outcnt)
	set w [TkMan]
	manOutput

	return $w
}


proc manOutput {} {
	global manx

	set wins [lmatches ".man*" [winfo children .]]

	# make list of output choices
	foreach i [lsort -command manWinSort $wins] {
		set title "#[string range $i 4 end]"
		# special case for main window
		if {$title=="#"} {append title 1}
		lappend titleList [list $title $i]
	}

	# update list on each instantiation
	foreach w $wins {
		set m $w.output.m
		$m delete 0 last
		foreach i $titleList {
			$m add radiobutton -label [lfirst $i] \
				-variable manx(out$w) -value [lsecond $i]
		}
	}
	manMenuFit $m

	# if pointing to a zapped instance, reset to self
	foreach w $wins {
		if ![winfo exists $manx(out$w)] {set manx(out$w) $w}
	}

	# if multiple choices, show menu
	if {$manx(outcnt)==1} {
		pack forget .man.output
	} else {
		foreach w $wins {pack $w.output -before $w.occ -padx 2 -side left -expand yes}
	}
}

proc manWinSort {a b} {
	set an [string range $a 4 end]
	set bn [string range $b 4 end]
	if {$an==""} {return -1} elseif {$bn==""} {return 1}

	if {$an<$bn} {return -1} elseif {$an==$bn} {return 0} else {return 1}
}


#--------------------------------------------------
#
# Highlights
#
#--------------------------------------------------

# get old highlights and yview, if any

proc manHighView {w} {
	global manx

	set t $w.show
	if ![catch {set y $manx(yview,$manx(hv$w))}] {
		$t yview moveto $y
		$t mark set xmark [$t index @0,0]
	}
	manHighlights $w get
}


# highlighting commands: update (menu), get (all from database)

proc manHighlights {w {cmd update}} {
	global high man manx

	set m [set mb $w.high].m
	$m delete 0 last
	set t $w.show

	# get/save tags
	set f $manx(hv$w)
	if [string match <* $f] {set f [string range $f 1 end]}
	# canonical file name
	if ![catch {set sf [file readlink $f]}] {
		if [string match /* $sf] {
			set f $sf
		} else {
			set f [file dirname $f]
			set strip 1
			while {$strip} {
				switch -glob $f {
					../* {set f [file dirname $f]; set sf [string range $sf 3 end]}
					./* {set sf [string range $sf 2 end]}
					default {set strip 0}
				}
			}
			append f /$sf
		}
	}
	set v high($f)
	set tags ""
	if {$cmd=="update"} {
		if {[file isfile $f]} {set tags "[file mtime $f] "} {set tags "-1 "}
		append tags [$t tag ranges highlight]
		if {$f!="" && [llength $tags]>1} {set $v $tags} {catch {unset $v}}
	} elseif {[info exists $v]} {
		if {![file isfile $f] || [file mtime $f]<=[lfirst [set $v]]} {
			set tags [set $v]
		} else {
			if {![tk_dialog .dialog Warning "Highlights out of date for $f.  Delete them?" "" 1 "No" "Yes"]} {
				set $v [set tags "[file mtime $f] [lrange [set $v] 1 end]"]
			}
		}
	}
#puts stdout "v = $v, f = $f"

	# update highlighting in text, menu
	set len [llength $tags]
	for {set i 1} {$i<$len} {incr i 2} {
		set first [lindex $tags $i]
		set last [lindex $tags [expr $i+1]]
		if {$cmd=="get"} {$t tag add highlight $first $last}
		set label \
			[tr [string range [string trim [$t get $first $last]] 0 $man(high,hcontext)] \012 " "]
		$m add command -label $label \
			-command "$t yview \[$t index \"$first - \$man(high,vcontext) lines\"\]"
#[max [expr $first-$man(high,vcontext)] 1]"
	}

	configurestate [list $mb $w.hsub] "$len>1"
	manMenuFit $m
}


#--------------------------------------------------
#
# file completion
#
#--------------------------------------------------

# should move core into taputils
proc manFilecomplete {w} {
	global manx

	set t $w.show; set wi $w.info
	set line $manx(typein$w)
	set file [string trim [llast $line] <]
	set posn [string last $file $line]

	set ll [llength [set fc [filecomplete $file]]]
#puts stdout "$line, $file, $posn, $fc"

	# check for no matches or more than one match
	if {!$ll} {
		winstderr $wi "no matches"
		return
	} elseif {$ll>=2} {
		foreach i $fc {lappend matches [file tail $i]}
		if {$ll<10} {
			winstderr $wi [lrest $matches]
		} else {
			manOpenText $w
			$t insert end [lrest $matches]
			manCloseText $w
		}
		set fc [lfirst $fc]
	}

	# show new file name
	set manx(typein$w) [string range $line 0 [expr $posn-1]]$fc

	$w.mantypein icursor end
	$w.mantypein xview moveto 1
}


#--------------------------------------------------
#
# manNewMode -- collect mode change inits in single place
#	 types of modes: section, man, txt, apropos, super, help
#
#--------------------------------------------------

proc manNewMode {w mode {n {""}}} {
	global man manx

	set t $w.show

	# save old highlights --> done continuously
#	manHighlights $w
	# save yview
	set manx(yview,$manx(hv$w)) [lfirst [$t yview]]

	set manx(oldmode$w) $manx(mode$w)
	set manx(mode$w) $mode
	set manx(manfull$w) ""
	set manx(catfull$w) ""
	set manx(man$w) ""
	set manx(name$w) ""
	set manx(num$w) ""

	# reset searching
#	set manx(search,string$w) ""
	set manx(search,oldstring$w) ""
	$w.search.cnt configure -text ""
	searchboxKeyNav "" Escape 0 $t "" 0
#	if {$mode=="section"} {searchboxKeyNav C s 0 $t "" 1}
	after 5 selection clear $t

#	set sbx(lastkeys$w) ""
	set manx(vect) 1
	set manx(try) 0
	$w.sections.m delete 0 last
	$w.links.m delete 0 last


	# disable various ui buttons for different types
	#   (paths, volumes, shortcuts, history always available)
	#
	#               man help txt section apropos super
	# yview          x   x    x     ?
	# sections       x   x
	# highlights     x   x    x
	# links          x   x
	# shortcuts +/-  x        x
	# print          x

	set high(0) disabled; set high(1) normal

	set h $high([lmatch {man help} $mode]); $w.sections configure -state $h
	set h $high([lmatch {man txt help} $mode])
		# $w.high state controlled by highlighting code
		foreach i {hadd} {$w.$i configure -state $h}
	if {![lmatch {man txt help} $mode]} {
		foreach i {high hsub} {$w.$i configure -state disabled}
	}
	set h $high([lmatch {man help} $mode]); $w.links configure -state $h
	if {![lmatch {man txt} $mode]} {
		foreach i {sadd ssub} {$w.$i configure -state disabled}
	}
	set h $high([lmatch man $mode]); $w.occ.m entryconfigure "Print" -state $h


	# hypertext (can key on section # if selecting from volume listing)
	bind $t <Double-ButtonRelease-1> "
#puts stderr {%W Double-ButtonRelease-1}
		if !\$tkPriv(mouseMoved) {
			manShowMan \[manHotSpot get %W @%x,%y\] $n $w
#\$manx(typein$w) $n $w
#
		}
	"
}



#--------------------------------------------------
#
# manXXX - miscellaneous medium-level commands
#
#--------------------------------------------------

proc manOpenText {w} {
	global man

	#raise $w
	cursorBusy
	set t $w.show
	$t configure -state normal
	$t delete 1.0 end
	# delete all the marks
	foreach i [$t mark names] {if {$i!="insert"&&$i!="current"} {$t mark unset $i}}
	$t configure -font $man(currentfont)
}

proc manCloseText {w} {
	set t $w.show

	# zap final newline so last line is flush with bottom
	if {[$t get "end -1c"]=="\n"} {$t delete "end -1c"}

	$t configure -state disabled
	cursorUnset
	$t mark set xmark 1.0
}

proc manResetEnv {} {
	global env man manx mani

	set manpath {}
	foreach i $manx(paths) {if {$man($i)} {append manpath :$i}}
	set env(MANPATH) [string range $manpath 1 end]

	# also updates contents of volume listings
	foreach i $manx(manList) {
		if {[lsearch $manx(specialvols) $i]==-1 || $i=="all"} {set mani($i,form) ""}
	}
}

proc manSetSect {w n} {
	global manx mani

	set manx(cursect$w) *

	# passed full pathname, search for section
	if [regexp {^/} $n] {
		set dir [file dirname $n]
		foreach vol $mani(manList) {
			if [lsearch -exact $mani($vol,dirs) $dir]!=-1 {
				set manx(cursect$w) $vol
#				set f [lsearch -exact $mani(manList) $vol]
				break
			}
		}

	# passed alphanum, use if valid
	} elseif {[set f [lsearch $manx(manList) $n]]!=-1} {
		set manx(cursect$w) $n
	}
#		$w.volnow configure -text "([lindex $manx(manList) $f]) [lindex $manx(manTitleList) $f]"
#$w.volnow configure -text ""
}

# put entire pulldown menu on screen, using smaller fonts if necessary
proc manMenuFit {m} {
	global man manx

	if {[winfo class $m]!="Menu"} {puts stderr "$m not of Menu class"; exit 1}
	if {[$m index last]=="none"} return

	set sh [winfo screenheight $m]

	# starting with current gui font size, pick smaller font as needed
	# until all entries fit on screen or out of smaller fonts
	set ok 0
	for {set i [expr [lsearch $manx(sizes) $man(gui-points)]+1]} {$i>=0} {incr i -1} {
		set p [lindex $manx(pts) $i]
		set f [spec2font $man(gui-family) $man(gui-style) $p]
		$m configure -font $f; update idletasks
		set mh [winfo reqheight $m]
#DEBUG {puts stderr "manMenuFit $m: $f, $mh, $sh"}
		if {$mh<$sh} {set ok 1; break}
	}

	# if menu still too big for screen, clip entries from bottom until it is
	if {!$ok} {
		set ctr 0
		# kind of heavyweight but don't need to do this often
		while {[winfo reqheight $m]>=$sh} {
			$m delete last; incr ctr; update idletasks
		}
		# make space for "too many" at bottom
		$m delete last; incr ctr
		$m add command -label "($ctr too many to show)" -state disabled
	}
}


#--------------------------------------------------
#
# manInit -- determine which sections exist,
#
#--------------------------------------------------

proc manInit {} {
	global man manx mani

	if {$manx(init)} return

	manReadSects
	# MANPATH may have shifted during startup
	manResetEnv
	set manx(init) 1
}


proc manReadSects {{w .man} {force 0} {msg "Building database ..."}} {
	global man manx mani winout env

	set wi $w.info
	if {[regexp $man(zregexp) $manx(database)]} {set manx(database) [file rootname $manx(database)]}


	# find name of database.  create if necessary
	set dbdir [file dirname $manx(database)]
	set database [lfirst [glob -nocomplain $manx(database).$man(zglob)]]

	if {$database=="" || $force || $manx(rebuildandquit)} {
		winstdout $wi $msg
		cursorBusy
		update idletasks

		## make database
		catch {eval exec $man(rm) -f [glob $manx(database).$man(zglob)]}
		set tmpfile $dbdir/.tkmantmp
		if [catch {set fid [open $tmpfile w]}] {
			puts stderr "Cannot write temporary information to $tmpfile"
			exit 1
		}
		set manx(manList) ""; set manx(manTitleList) ""; set manx(mandot) ""
		set manx(newmen) {}
		foreach i $mani(manList) {
			winstdout .man.info "$winout(lastMessage$wi) $i"; update idletasks
			if {[manReadSection $i $fid]!=0} {
				lappend manx(manList) $i
				lappend manx(manTitleList) [lindex $mani(manTitleList) [lsearch -exact $mani(manList) $i]]
			}
		}
		close $fid

		# identify it with summary information
		if [catch {set fid [open $manx(database) w]}] {
			puts stderr "Cannot write database to $manx(database)"
			exit 1
		}
		puts $fid "#\n# TkMan v$manx(version) database, created at [exec $man(date)]\n#"
		foreach i {manList manTitleList mandot} {
			puts $fid "# set manx($i) {$manx($i)}"
		}

		# database providence
		puts $fid "# set manx(db-manpath) $manx(MANPATH0)"
		puts $fid "# set manx(db-signature) [manDBsignature]"

		puts $fid "# set manx(newmen) [list $manx(newmen)]"


		# append listings from $tmpfile
# close $fid, then eval exec $man(mv) $tmpfile >> $manx(database) ?
		set fid2 [open $tmpfile]
		puts $fid [read $fid2]
		close $fid2
		close $fid

		## compress it
		# compression programs sometimes spit out statistics that exec interprets as errors
		# ==> better to know if compress has a problem, say no space left on device
		# ==> can't continue without the database, so crash if error
		if [catch {eval exec $man(compress) $manx(database)} info] {
			# assume messages reporting "%" compression are benign
			if ![string match "*%*" $info] {
				puts stderr "Problem compressing database --  $info"
				exit 1
			}
		}
		eval exec $man(rm) -f $tmpfile
		# should get exactly one glob match here
		set database [glob $manx(database).$man(zglob)]

		cursorUnset
		winstdout $wi "Database created in file [bolg $database ~]"
	}

	if {$manx(rebuildandquit)} {exit 0}

	# give manx(....file) the actual name, including compression suffix
	set manx(database) $database

	# read in database meta-information
	set fid [open "|$man(zcat) $manx(database)"]
	while {[gets $fid line]!=-1 && [regexp {^#} $line]} {
		if {[regexp {^# (set .*)} $line all set]} {eval $set}
	}
	# catch because pipe not empty
	catch {close $fid}

	# database validity checks
	# see if any manual page directories updated since database built
	# (I hope this doesn't happen too often)
	set outofdate 0
	if {!$force && !$manx(now) && [file exists $database]} {
		set lastupdate [file mtime $database]; set maxdir ""; set maxdirtime 0
# get stuff from last week
#DEBUG {set lastupdate [expr $lastupdate-(7*60*60*24)]}
#puts "\n$lastupdate   $database\n"
		foreach i $mani(manList) {
			foreach j $mani($i,dirs) {
				foreach k [glob -nocomplain $j*] {
#puts "[file mtime $k]   $k"
					set dirupdate [file mtime $k]
					if {$maxdirtime<$dirupdate} {set maxdirtime $dirupdate; set maxdir $k}
					if {$lastupdate<$dirupdate} {
DEBUG {puts "$k:  [file mtime $k] > $lastupdate"}
						set outofdate 1
					}
				}
			}
		}
	}

	set rmsg ""
	if {$outofdate} {
		set rmsg "Database out of date"
	} elseif {!$force && $manx(now)} {
		# nothing
	} elseif {$manx(MANPATH0)!=$manx(db-manpath)} {
		set rmsg "MANPATH changed"
DEBUG {puts "$manx(db-manpath) => $manx(MANPATH0)"}
	} elseif {[manDBsignature]!=$manx(db-signature)} {
		set rmsg "New tkmandesc configuration"
DEBUG {puts "$manx(db-signature) =>\n[manDBsignature]"}
	}
	if {[string length $rmsg]} {
		if ![file writable $dbdir] {
			after 2 "winstderr $wi \"$rmsg ... but database directory not writable\""
		} else {
			manReadSects $w 1 "$rmsg, rebuilding ..."
			# check for misset clocks (leaving some man directory with later time than new database)
			set newupdate [file mtime $manx(database)]
			if {$newupdate<$maxdirtime} {
				set errmsg "
					Problem with file and directory times...\a\a
					The newly created database ($manx(database)) has its time set
					earlier than the $maxdir directory and perhaps others.
					Unless corrected, the database will be rebuilt every time
					TkMan is started.  Perhaps you need to reset your system clock.
				"
				puts stderr [linebreak $errmsg 70]
			}

			# important return below
			return
		}
	}

	# dynamically formatted
	foreach i $manx(manList) {set mani($i,form) ""}

	# add standard pseudo-volumes
	foreach i $manx(extravols) {
		set letter [lfirst $i]; set title [lsecond $i]; set msg [lthird $i]
		lappend manx(manList) $letter; lappend manx(manTitleList) $title
		set mani($letter,form) $msg; set mani($letter,cnt) 0
	}


#	if {$outofdate} {manHelp $w}
	### also need to rebuild section pulldown here
	foreach i [lmatches ".man*" [winfo children .]] {manMakeVolList $w}
}



#--------------------------------------------------
#
# manReadSection
#
#--------------------------------------------------

proc manReadSection {n fid} {
	global man manx mani env

	# follow all paths here, even if search presently turned off for that dir
	if ![info exists mani($n,dirs)] {return 0}

	set title [lindex $mani(manTitleList) [lsearch $mani(manList) $n]]
DEBUG { puts -nonewline stderr $n }
#	set mani($n) ""
	set first 1
	set cnt 0

	# collect recent additions/changes
	if {![catch {set lines [eval exec $man(find) $mani($n,dirs) -type f -mtime -$man(recentdays) -print]}] && $lines!=""} {
DEBUG {puts -nonewline "F"}
		set short {}
		foreach k [lsort $lines] {
			set f [file tail $k]
			if [regexp $man(zregexp) $f] {set f [file rootname $f]}
			if {![string match "*~" $f]} {lappend short $f}
		}
		# guard against directory change being deleted files only
		if {$short!=""} {lappend manx(newmen) [list $n $short]}
	}


	# collect names from directory
	foreach i $mani($n,dirs) {
		foreach k [glob -nocomplain $i/*] {
#DEBUG { puts stderr $k }
			if {$first} {puts $fid "$n [list $title]"; set first 0}
			set f [file tail $k]; set sgi [string match "*/cat*/*.z" $k]
			if [regexp $man(zregexp) $f] {set f [file rootname $f]}
			# no Emacs backup files (~) and simple check for manual page-ness (contains a ".")
			# ==> SGI doesn't have any dots after chopping off .z!
			if {![string match "*~" $f]} {
				if {[string match "*.*" $f] || $sgi} {
					puts $fid $k
					incr cnt

					# amass mandots
					if {[regexp {\..*\.} $f] || ($sgi && [regexp {\.} $f])} {
						lappend manx(mandot) [file rootname $f]
					}
				}
			}
		}
	}

	return $cnt
}


proc manFormatSect {n} {
	global man manx mani high

	set form ""

	if {$n=="high"} {
		set mani(high,form) ""
		set ltmp [lsort -command manSortByName [array names high]]
		foreach k $ltmp {
			if {[llength $k]>1 || $k=="*"} continue
			append mani(high,form) $k\n
		}
		set mani(high,cnt) [llength $mani(high,form)]
		if {$mani(high,cnt)==0} {set mani(high,form) "No manual pages have been annotated.\n"}

		return

	} elseif {$n=="recent"} {
		set first 1; set form ""; set cnt 0
		foreach i $manx(newmen) {
			set vol [lfirst $i]; set names [lsecond $i]
			if {$first} {set first 0} {append form "\n\n\n"}
			if {[set index [lsearch $mani(manList) $vol]]!=-1} {
				set voltxt "volume $vol, \"[lindex $mani(manTitleList) $index]\""
			} else { set voltxt $vol }
			append form "In $voltxt ...\n\n"
			foreach i $names {append form $i "\t"; incr cnt}
		}
		set mani(recent,cnt) $cnt
		if {$mani(recent,cnt)==0} {
			set form "There are no manual pages less than $man(recentdays) day"
			if {$man(recentdays)>1} {append form "s"}
			append form " old.\n"
		}
		set mani(recent,form) $form
		return
	}


	# get all the names -- wow, sed actually is useful,
	#    though it could use the regular expressions it claims it has, like the '|' operator
	# show only pages in current volumes
	# (only volume header lines have spaces)
	if {$n=="all"} {set sect ""} {set sect "-e {/^$n /,/ /!d}"}
	set sed "$man(sed) $sect -e {/ /d}"
	# exclude pages from disabled paths
	foreach i $manx(paths) {
		if {[info exists man($i)] && !$man($i)} {
			append sed " -e {\\?^$i?d}"
		}
	}
	# delete the directory, leaving just the filename
	append sed " -e {s/.*\\///g}"
#-e {s/\\.z\$//}  -e {s/\\.gz\$//}  -e {s/\\.Z\$//}
DEBUG {puts "sed = $sed"}
	set ltmp [eval exec "$man(zcat) $manx(database) | $sed | $man(sort)"]
	#set ltmp [lsort [eval exec "$man(zcat) $manx(database) | $sed"]]}]

	if {$man(volcol)=="0"} {set sep "  "} {set sep "\t"}
#	set cnt [llength $ltmp]
	set cnt 0

	# specialized version of uniqlist
	set pr ""; set pe ""; set pl ""
	set online 0; set skip 0
#set xtmp [lfirst $ltmp]; set xdir [file dirname [file dirname $xtmp]]
#puts "$xtmp => $xdir, exists [info exists man($xdir)], ok $man($xdir)"
	foreach i $ltmp {
		if [regexp $man(zregexp) $i] {set i [file rootname $i]}
		set ir [file rootname $i]; set ie [file extension $i]; set il [string tolower [string range $i 0 0]]

		if {$pl!=$il && $online>0} {
# && ($n==3 || ![string match {[A-Z]} [string range $i 0 0]])} {
			append form "\n\n"
			set online 0
		}

		if {$pr!=$ir} {
			if {$online!=0} {append form $sep}
			append form $ir; incr online
			set skip 0
		} elseif {$pe==$ie} {
#			append form +
#			set skip 0
		} else {
			if {$online!=0} {
				if {!$skip} {append form $pe}
				append form $sep
			}
			append form $i; incr online
			set skip 1
		}

		set pr $ir; set pe $ie; set pl $il
		incr cnt
	}

	if {$cnt==0} {set form "No man pages in currently enabled paths.\nTry turning on some under the Paths pulldown menu."}
	set mani($n,form) $form
	set mani($n,cnt) $cnt
}


# calculate signature on paths used to build database,
# so can identify changes in MANPATH and with tkmandesc, and rebuild automatically

proc manDBsignature {} {
	global mani

	# set first character of sig to letter so Tcl won't try to interpret string as a number
	set sig "X"
	foreach i $mani(manList) {
		if [info exists mani($i,dirs)] {append sig $i[llength $mani($i,dirs)]}
	}
	return $sig
}


#--------------------------------------------------
#
# mandesc -like features
#
# mani(<single letter>) => name of full title main index
# mani(<letter>) => listing of full dir & list of names
# mani(<letter>,form) => formatted?
# mani(<letter>,cnt) => # of entries
# mani(<letter>,dirs) => paths x sections cross product, w/mandesc diddling
# --> everybody has a letter and letters aren't repeated
#
#--------------------------------------------------


# cross product of paths by sections
# if LANG environment variable is set, first try to read directories with that name

proc manDescDefaults {} {
	global man manx mani env

	# don't check manx(defaults) here
	manDescManiCheck return

	if [info exists env(LANG)] {set langs [split $env(LANG) ":"]} {set langs ""}
	foreach i $mani(manList) { set mani($i,dirs) {} }
	foreach i $manx(paths) { set mani($i,dirs) {} }
	set mani($man(glimpsestrays),dirs) {}
	set curdir [pwd]

	foreach i $manx(paths) {
		cd $i
		set alldirs [glob -nocomplain $manx(subdirs)]
		foreach l $langs {
			set alldirs [concat $alldirs [glob -nocomplain $l/$manx(subdirs)]]
		}
#DEBUG {puts "    alldirs = $alldirs"}
DEBUG {puts "    sorted alldirs = [lsort -command bytypenum $alldirs]"}
		foreach d [lsort -command bytypenum $alldirs] {
			if {[string match "*/*" $d]} {
				set lang "[file dirname $d]/"; set dir [file tail $d]
			} else {set lang ""; set dir $d }
			# keep both manN and manN.Z, with manN.Z preferred
#			set dir [file rootname $d]; set type [string range $dir 0 2]
			set dirsig [string range $dir $manx(dirnameindex) end]
			# purpose of following line?
			if {[string match "cat*" $dir]} {set dirsig [file rootname $dirsig]}
			set num [file rootname $dirsig]; set num1 [string index $num 0]

			# what section group does it belong to?
			if {[lsearch -exact $mani(manList) $num]!=-1} {set n $num} {set n $num1}

			# check for conflicts with other abbreviations starting with same letter
			set pat "^[stringregexpesc $i]/${lang}(man|cat)[stringregexpesc $dirsig]\$"
			set dir $i/$d
			if {[lsearch -regexp $mani($i,dirs) $pat]==-1 && [manPathCheckDir $dir]==""} {
# following line would be a good check, but takes too long to start up -- actually, part of manPathCheckDir
#				 && [glob -nocomplain $dir/*]!=""} {
				lappend mani($i,dirs) $dir
				lappend mani($n,dirs) $dir
			}
		}
DEBUG {puts "mani($i,dirs) = $mani($i,dirs)"}
	}
DEBUG {foreach i $mani(manList) { puts "mani($i,dirs) = $mani($i,dirs)" }}

	cd $curdir
	set manx(defaults) 1
}

proc bytypenum {a b} {
	if [string match "*/*" $a] { set al [file dirname $a]; set a [file tail $a] } {set al ""}
	if [string match "*.Z" $a] { set as [file extension $a]; set a [file rootname $a] } {set as ""}
	set at [string range $a 0 2]
	if [string match "*/*" $b] { set bl [file dirname $b]; set b [file tail $b] } {set bl ""}
	if [string match "*.Z" $b] { set bs [file extension $b]; set b [file rootname $b] } {set bs ""}
	set bt [string range $b 0 2]

	# priority: language, type (man or cat), number, .Z suffix
	if {$al!=$bl} {
		if {$al==""} {return 1} elseif {$bl==""} {return -1} elseif {$al<$bl} {return -1} {return 1}
	} elseif {$at!=$bt} {
		if {$at=="man"} {return -1} {return 1}
	} elseif {$as!=$bs} {
		# prefer .Z
		if {$as==""} {return 1} {return -1}
	} else {
		if {$a<$b} {return -1} {return 1}
	}

	return 0
}


# commands: move, copy, delete
# from, to *list* of source, target dirs
# list is list of directory *patterns*

proc manDescMove {from to dirs} {manDesc move $from $to $dirs}
proc manDescDelete {from dirs} {manDesc delete $from "" $dirs}
proc manDescCopy {from to dirs} {manDesc copy $from $to $dirs}
proc manDescAdd {to dirs} {
	global mani manx man

	set warnings ""

	manDescManiCheck
	foreach d $dirs {
		if {[set warnmsg [manPathCheckDir $d]]!=""} {
			append warnings $warnmsg
		} else {
			foreach t $to {lappend mani($t,dirs) $d}

			# try to attach these oddball directories to some MANPATH
			# in order to make them available for Glimpse indexing
DEBUG {puts "MANPATH for $d?"}
			set mp $d
			while {[string match "/*" $mp] && $mp!="/"} {
				if {[lsearch -exact $manx(paths) $mp]>=0} {
DEBUG {puts "\tyes, in $mp"}
					lappend mani($mp,dirs) $d; break
				} else {set mp [file dirname $mp]}
			}
			if {$mp=="/"} { lappend mani($man(glimpsestrays),dirs) $d
DEBUG {puts "\tno, added to strays\n\t\tnow mani($man(glimpsestrays),dirs) =  $mani($man(glimpsestrays),dirs)"}
			}
		}
	}


	if {$warnings!=""} {
		if ![string match *manDescAdd* $manx(warnings)] {
			append manx(warnings) "Problems with manDescAdd's...\n"
		}
		append manx(warnings) $warnings
	}
}


proc manDesc {cmd from to dirs} {
	global man manx mani

	manDescManiCheck
	if {$from=="*"} {set from $mani(manList)}
	if {$to=="*"} {set to $mani(manList)}
	foreach n [concat $from $to] {
		if [lsearch $mani(manList) $n]==-1 {
			puts stderr "$cmd: Section letter `$n' doesn't exist."
			exit 1
		}
	}

DEBUG {puts stdout "$cmd {$from} {$to} {$dirs}"}
	foreach d $dirs {
		foreach f $from {
			set newdir {}
			foreach fi $mani($f,dirs) {
				if [string match $d $fi] {
					if {$cmd=="copy"} {lappend newdir $fi}
					if {$cmd=="copy"||$cmd=="move"} {
						foreach t $to {if {$f!=$t} {lappend mani($t,dirs) $fi} {lappend newdir $fi}}
					}
				} else {lappend newdir $fi}
			}
			set mani($f,dirs) $newdir
DEBUG {puts stdout $f:$mani($f,dirs)}
		}
	}
}

proc manDescAddSects {l {posn "end"} {what "n"}} {
	global man mani

	manDescManiCheck
	if {$posn=="before"||$posn=="after"} {set l [lreverse $l]}
	foreach i $l {
		set n [lfirst $i]; set tit [lsecond $i]
		if [lsearch $mani(manList) $n]!=-1 {
			puts stderr "Section letter `$n' already in use; request ignored."
			continue
		}

		if {$posn=="end"} {
			lappend mani(manList) $n
			lappend mani(manTitleList) $tit

		} elseif {$posn=="before"||$posn=="after"} {
			if [set ndx [lsearch $mani(manList) $what]]==-1 {
				puts stderr "Requested $posn $what, but $what doesn't exist; request ignored"
				continue
			}
			if {$posn=="after"} {incr ndx}
			set mani(manList) [linsert $mani(manList) $ndx $n]
			set mani(manTitleList) [linsert $mani(manTitleList) $ndx $tit]

		} elseif {$posn=="sort"} {
			lappend mani(manList) $n
			set mani(manList) [lsort $mani(manList)]
			set ndx [lsearch $mani(manList) $n]
			set mani(manTitleList) [linsert $mani(manTitleList) $ndx $tit]
		}

		set mani($n,dirs) {}
	}
}


# if mani array, matrix not already created, do it now

proc manDescManiCheck {{action "exit"}} {
	global man mani manx env

	# check for missing call to manDot
	if {!$manx(manDot)} manDot

	if ![info exists mani(manList)] {
		set mani(manList) $man(manList)
		set mani(manTitleList) $man(manTitleList)

		# have to be done playing with MANPATH before start playing with results
		manManpathSet
		manManpathCheck

		if {$action=="return"} return
		manDescDefaults
	}
}


# place SGI's magically-appearing catman subdirectories into volumes

proc manDescSGI {patterns} {
	global man manx mani

	# start up checks for patterns
	# (=> maybe go with (vol name pats) tuples)

	set paterrs 0
	foreach pat $patterns {
		set mapto [lindex $pat 0]; set patlist [lindex $pat 1]

		# make sure each mapping exists as a volume that's been added
		if [lsearch -regexp $mani(manList) ".?$mapto"]==-1 {
			puts stderr "no volume corresponding to $mapto mapping (patterns: $patlist)"
			incr paterrs
		}

		# make sure patterns don't overlap
		#    can't have identical patterns (ftn =>! 2f and 3ftn.)
		#    either: 2/ftn=>2f and 3/ftn=>3ftn)  *or*  merge with ftn => 2ftn and 3ftn
		foreach p $patlist {
			foreach pat2 $patterns {
				if {$pat==$pat2} break
				set mapto2 [lindex $pat2 0]; set patlist2 [lindex $pat2 1]
				foreach p2 $patlist2 {
					if [string match $p2 $p] {
						puts stderr "pattern $p never reached -- $mapto2's $p2 precludes it"
						incr paterrs
					}
				}
			}
		}
	}

	# add a guaranteed match, that's placed in single-letter volume
	lappend patterns {"" {""}}
	DEBUG {puts "mani(manList) => $mani(manList)"}

	# collect .../catman directories (know they're readable by this point)
	set catmen {}
	foreach d [split $manx(MANPATH0) ":"] {
		if [string match "*/catman" $d] { lappend catmen $d }
	}
	if ![llength $catmen] {
		puts stderr "No seaky catman directories found in MANPATH:\n\t$manx(MANPATH0)"
		exit 1
	}


	if [catch {set catmandirs [eval exec $man(find) $catmen -type d -print]} info] {
		puts stderr "Trouble reading $catmen -- $info"
		set catmandirs {}
	}

	foreach dir $catmandirs {
		if [regexp {(catman|_man)$} $dir] continue
		set tail [file tail $dir]
		set vol [file tail [file dirname $dir]]
		if ![regexp "^(man|cat)" $vol] { set vol $tail; set tail "" }

		set volnum [string range $vol 3 3]

		DEBUG {puts -nonewline "$dir ($vol:$tail ($volnum)) => "}
		set matched 0
		foreach pat $patterns {
			set mapto [lindex $pat 0]; set patlist [lindex $pat 1]
			foreach dp $patlist {
				if [string match "*$dp" $dir] {
					DEBUG {puts -nonewline "match on $dp => "}
					set matched 1
					# first try to place in mapto name in current volume
					if [lsearch -exact $mani(manList) "$volnum$mapto"]!=-1 {
						DEBUG {puts $volnum$mapto}
						manDescAdd "$volnum$mapto" $dir

					# then try mapto name in any volume
					} elseif [lsearch -exact $mani(manList) $mapto]!=-1 {
						DEBUG {puts $mapto}
						manDescAdd $mapto $dir

			 		# else place in a parent volume
					} elseif [lsearch -exact $mani(manList) $volnum]!=-1 {
						DEBUG {puts $volnum}
						manDescAdd $volnum $dir

					} else {
						DEBUG {puts "can't place"}
					}

					break
				}
			}
			if {$matched} break
		}
		DEBUG {if {!$matched} {puts "CAN'T MATCH\a\a"}}
	}
}



# for debugging
proc manDescShow {} {
	global man manx mani

	manDescManiCheck
	puts stdout "*** manDescShow"
	foreach i $mani(manList) {
		if [info exists mani($i,dirs)] {puts stdout $i:$mani($i,dirs)}
	}
}



#--------------------------------------------------
#
# manShowSection -- show listing
#
#--------------------------------------------------

proc manShowSection {w n} {
	global man manx mani high font

	if {[lsearch $manx(manList) $n]==-1} { winstderr $w.info "Volume $n not found"; return }
	if $manx(shift) { set manx(shift) 0; set w [manInstantiate] }
	set t $w.show; set wi $w.info

	manNewMode $w section $n
	set manx(lastvol$w) $n
	set manx(hv$w) $n

	set head [lindex $manx(manTitleList) [lsearch $manx(manList) $n]]

	if {$mani($n,form)==""} {
		cursorBusy
		winstdout $wi "Formatting $head ..."; update idletasks
		manFormatSect $n
		cursorUnset
	}

	winstdout $wi $head
	manSetSect $w $n

	manOpenText $w
	$t configure -font $font(vol)
	$t insert end $mani($n,form)
	$w.search.cnt configure -text "$mani($n,cnt) entries"
	manCloseText $w
	manHighView $w
#	focus $t
	# apropos needs special formatting tags
	if {$n=="apropos"} {$t tag add apropos 1.0 end}

	# rewrite "Last volume viewed" to show what volume that will be
	set lastvol [$w.vols.m cget -tearoff]
	$w.vols.m entryconfigure $lastvol -label "($n) $head" -state normal
	set manx(name$w) $head
}


proc manSortByName {a b} {
	set c [string tolower [file tail $a]]; set d [string tolower [file tail $b]]
	if {$c<$d} {set cmp -1} elseif {$c==$d} {set cmp 0} {set cmp 1}
	return $cmp
}



#--------------------------------------------------
#
# manShowMan -- given various formats of names,
#	 search for that man page.  if successful, call manShowManFound
#
# don't use `man' to show because may want to *always*
#	 format with my own macros
#
#--------------------------------------------------

proc manShowMan {fname {goodnum ""} {w .man}} {
	global man manx mani env
#puts stdout "manShowMan: $fname $goodnum $w"

	if $manx(shift) { set manx(shift) 0; set w [manInstantiate] }
	set wi $w.info

	# establish valid variable values
	if {[string trim $fname]==""} return
	# goodnum comes from double clicks from sections or previously parsed section number
	if {[lsearch $manx(specialvols) $goodnum]!=-1} {set goodnum ""}

	# given full path?  if so, don't need to search
	if {[regexp {^(\.\./|\./|[~/$])} $fname]} {
#puts "full path match on $fname"
		manShowManFound [fileexp [lfirst $fname]] 0 $w
		return
	}

	# `|command' for shell command, whose text is sucked into search box,
	#    to use with lman, say
	# `< file' syntax for file to suck up raw text
	# for more sophisticated file reading, use NBT

	if {[regexp {^[|<]} $fname]} {manShowText $fname $w; return}


	### need to search for name

	# construct stem, section, extension
	set oname [string trimright [string trim [lfirst $fname] { ,?!;"'}] .]
	if {$goodnum!=""} {set tmp "($goodnum)"} {set tmp ""}
	winstdout $wi "Searching for \"$oname$tmp\" ..."; update idletasks
	set fname [string tolower $oname]; # lc w/  () for regexp
	set sname [string trim $fname ()]; # lc w/o ()
	set oname [string trim $oname ()]; # original case w/o ()

	set name $sname; set num ""; set ext ""
# set sect {\..};

	# extract section number in `man(sect)' format
	if {[regexp -nocase {([a-z0-9_.+-]+)([\t ]*)\(([^)]?)(.*)\)} $fname \
		 all name spc num ext]} {
#		set sed "| $man(sed) /^$num /,/^\[^$num\] /p;d"
#		set sect "\\\..$ext"

	# if you have a dot, assume it's the section number
	} elseif {[regexp {(.+)\.(.)([^.]*)$} $oname all namex sectx extx]
# bad sections fixed up later--just check for mandots here
		&& [lsearch -exact $manx(manList) $sectx]!=-1
		&& [lsearch -exact $manx(mandot) $oname]==-1} {
#		set sect {\.}
		set name $namex; set num $sectx; set ext $extx
#		set num [string trimleft [file extension $oname] .]
#		set name [file rootname $oname]
#		set sed "| $man(sed) /^$num\$/,/^\[^$num\]\$/ p; d"
DEBUG {puts "num = $num"}
	}


	# given section number
	if {$goodnum!=""} {
#		set sect "\\\.$goodnum"
#		set sect {\.}
#		set sed "| $man(sed) /^$goodnum /,/^\[^$goodnum\] /p;d"
		set num $goodnum
	}

	# check for multicharacter section "letters"
	if {[lsearch -exact $manx(manList) "$num$ext"]!=-1} {
		set num "$num$ext"; set ext ""
	}

# get section number in `man.sect' format
# no .z's here

	set ext [string tolower $ext]
	if $man(shortnames) {set name [string range $name 0 10].*}

#, sect = $sect

	cursorBusy
DEBUG {puts stdout "$name : $num : $ext"}
	set foundList [manShowManSearch $name $num $ext]
	cursorUnset

	# if no matches with extension, look for one without
	set found [llength $foundList]
	if {!$found} {
		if {$ext!=""} {manShowMan $name $num $w; return} \
		elseif {$num!="" || [set rootname [file rootname $name]]!=$name} {
			manShowMan [file rootname $name] {} $w
			return
		}
	}

	# act on results of search
	if {!$found} {
		winstderr $wi "$sname not found"
		set r "ERROR: manual page not found"
	} else {
		set orname [file rootname $oname]
#puts "sorting $foundList"
		set prioritylist [lsort -command {manShowManSort $orname $manx(cursect$w) $num $ext} $foundList]
		manShowManFound $prioritylist 0 $w
		set r [lfirst $prioritylist]
	}

	# set return value for remote calls
	return $r
}


proc manShowManSort {orname onum num ext a b} {
	global manx

	set pa [manShowManPriority $a $num $ext $orname $onum]
	set pb [manShowManPriority $b $num $ext $orname $onum]

	# greater priority placed earlier
	if {$pa>$pb} {set r -1} elseif {$pa<$pb} {set r 1} else {set r 0}
	return $r
}

proc manShowManPriority {m num ext orname onum} {
	global man manx mani

	# locals: d=directory, t=tail, n=number, e=extention
	set d [file dirname $m]; set t [file tail $m]
	set r [file rootname $t]; set n [file extension $t]
	if {[regexp $man(zregexp) $n]} {set n [file extension $r]; set r [file rootname $r]}
	set e [string range $n 2 end]; set n [string range $n 1 1]

	# determine priority value
	# levels: name, lc names, num, ext, num==onum
	set pri 0
# I think $n==$num is true for all or none
	if {$n==$num} {incr pri 16} elseif {$n==$onum} {incr pri 1}
	if {$r==$orname} {incr pri 8} elseif {[string tolower $r]==[string tolower $orname]} {incr pri 4}
	if {$n==$ext} {incr pri 2}
	set pri [expr $pri*128]

	# tie breaker #1: MANPATH order
	set p -1; set l [llength $manx(paths)]
	while {$d!="/" && [set p [lsearch -glob $manx(paths) $d*]]==-1} {
		set d [file dirname $d]
	}

	# should manDescAdd directories be first or last?
	if {$p==-1} {set p $l}
	incr pri [expr $l-$p]
	set pri [expr $pri*128]

	# tie breaker #2: section number order
	set l [llength $mani(manList)]
	set p [lsearch -exact $mani(manList) $n]; if {$p==-1} {set p $l}
	incr pri [expr $l-$p]

	return $pri
}


# given name, number and extension of manual page,
# return a list of matches as full pathnames

proc manShowManSearch {name num ext} {
	global man manx

	set sed "$man(sed)"
	if [lsearch $manx(manList) $num]==-1 {
		set num ""
	} else {
		append sed " -e {/^$num /,/^\[^$num\] /!d}"
	}
	append sed " -e {/^. /d}"
DEBUG {puts "sed = $sed"}


	# search for man page
	set foundList ""
# sect handled with sed
#	set sect [if {$num!=""} {format "\.$num"} {format ""}]

	# get all potential matches, then filter against active MANPATH components
	# no $num in setting pat below as $num used in sed filter
	set pat "/$name\\..$ext\[^/\]*\$"
DEBUG {puts stderr "searching for $pat"}
DEBUG {puts stderr "set fid \[open \"|$man(zcat) $manx(database) | $sed | $man(grep) -i $pat\"\]"}
	set fid [open "|$man(zcat) $manx(database) | $sed | $man(grep) -i {$pat}"]
	while {[gets $fid f]!=-1} {
#		gets $fid f; if {$f==""} continue
		set d [file dirname [file dirname $f]]
#puts -nonewline stderr "considering $f"
		if {(![info exists man($d)] || $man($d)) && [lsearch $foundList $f]==-1 } {
			lappend foundList $f
		}
	}
	catch {close $fid}

	return $foundList
}



#--------------------------------------------------
#
# manShowManFound -- display man page and update gui with parse info
#
# invariants:
#	 manx(catfull$w)!="" iff loaded from .../cat. directory
#--------------------------------------------------

proc manShowManFound {f {keep 0} {w .man}} {
	global man manx

	set t $manx(out$w).show; set wi $w.info
	set f [string trim $f]

	# update gui
	set flen [llength $f]
	if {$flen>1} {
		# multiple matches
		pack $w.dups -before $w.mantypein -side left -anchor e; $w.dups configure -state active
		set m $w.dups.m
		$m delete 0 last
		foreach i $f {$m add command -label $i -command "manShowManFound $i 1 $w"}
		manMenuFit $m

		set f [lfirst $f]
	} elseif {!$keep} {pack forget $w.dups}
#	if {!$keep} {pack forget $w.dups; #$w.dups.m unpost}

	manNewMode $w man
	set manx(lastman) [set f0 $f]
	set manx(links) ""


	# only redirect text of man pages
	if {[winfo exists $manx(out$w)]} {set w $manx(out$w)} {set manx(out$w) $w}
	# passed filename may or may not have (i.e., need) compression suffix
	if {[set fg [lfirst [glob -nocomplain $f*]]]==""} {
		winstderr $wi "$f doesn't exist"
		return
	} else {set f $fg}
	if [file isdirectory $f] {
		winstderr $wi "$f is a directory"
		return
	}

	# for relative names w/. and ..
	set tmpdir [file dirname $f]
#	set f [stringesc $f $manx(regexpmetachars)]
#puts "$f => $f"

	# on first line, check for single-line .so file pointing to a compressed destination
	# on second line, check for "  Purpose" as sign of IBM AIX manual page
	set so 0
#	catch {
	set line1 [set line2 ""]
	if {[file readable $f]} {
		set fid [open "|[manManPipe $f]"]
		while {([string trim $line1]=="" || [regexp {^[.']\\"} $line1]) && ![eof $fid]} {gets $fid line1}
		while {[string trim $line2]=="" && ![eof $fid]} {gets $fid line2}
		catch {close $fid}
#puts stderr "***$line1***\n***$line2***"
		# don't be fooled by simple inclusion of macro file
		if {[regexp {^\.so (man.+/.+)} $line1 all newman]} {
DEBUG {puts stderr "*** single-line .so => $manx(manfull$w): $line1"}
			# glob here as redirected file may be compressed
			# (catch in case destination of .so doesn't exist)
			if [catch {set f [lfirst [glob [file dirname $tmpdir]/$newman*]]}] return
			set tmpdir [file dirname $f]
			set so 1
DEBUG {puts stderr "*** new f => $f"}
		}
	}
#	}

	# set variables
	set manx(manfull$w) $f
	set manx(man$w) [file tail $f]
	if {[regexp $man(zregexp) $manx(man$w)]} {set manx(man$w) [file rootname $manx(man$w)]}
	set manx(name$w) [string trimright [file rootname $manx(man$w)] "\\"]

	set fdir [file dirname $manx(manfull$w)]
	set topdir [file dirname $fdir]
	# strip trailing Z's
	if {[regexp $man(zregexp) $fdir]} {set fdir [file rootname $fdir]}
#	set manx(num$w) [string index $fdir [expr [string length $fdir]-1]]
#puts "$fdir => [string range [file tail $fdir] 3 end]"
	set manx(num$w) [string range [file tail $fdir] $manx(dirnameindex) end]
	if {[lsearch $man(manList) $manx(num$w)]==-1} {set manx(num$w) [string index $manx(num$w) 0]}
#puts "manx(num\$w) = $manx(num$w)"
#	set manx(num$w) [string range [file extension $manx(man$w)] 1 1]
#	if {[file extension $manx(man$w)]==".man"} {set manx(num$w) [string range [file dirname $f] 1 1]}
	set fsstnd ""
	# if cat-only, then set manfull is cat already
	if {[regexp $man(catsig) $fdir]} {
#[string match */cat?*/* $f]} {
# $tmpdir] || [string match */cat?* [file dirname $tmpdir]]} {
		set manx(catfull$w) $manx(manfull$w)

		if {$line2=="  Purpose"} {
			manShowText $f $w 1
			set manx(typein$w) [set manx(name$w) [file rootname [set manx(man$w) [file tail $f]]]]
			return
		}
	} else {
		# /usr/<blah/>man/manN/<name> => /var/catman/<blah>/catN/<name>
DEBUG {puts "regexp on $topdir"}
		if {[regexp {^/usr/(.*)man$} $topdir all blah]} {
			set fsstnd "/var/catman/${blah}cat$manx(num$w)/$manx(name$w).*"
DEBUG {puts "*** fsstnd = $fsstnd"}
		}
		set manx(catfull$w) $topdir/cat$manx(num$w)*/$manx(name$w).*
	}
	set manx(cat) $topdir/cat$manx(num$w)


    # for case of source a link to nowhere but formatted version OK (yeesh)
	if [catch {set manfullmtime [file mtime $manx(manfull$w)]}] {set manfullmtime 0}

	# check for already-formatted man page that's up to date vis-a-vis source code
	if {[set path [lfirst [glob -nocomplain $manx(catfull$w)]]]!=""
		&& [file readable $path] && [file mtime $path]>=$manfullmtime} {
		set manx(catfull$w) $path
		set pipe [manManPipe $path]

	# check for cat version in /var/catman... according to Linux FSSTND
	} elseif {$fsstnd!="" && [set path [lfirst [glob -nocomplain $fsstnd]]]!="" &&
		[file readable $path] && [file mtime $path]>=$manfullmtime} {
		set manx(catfull$w) $path
		set manx(cat) [file dirname $path]
		set pipe [manManPipe $path]

	# need to format from roff source
	} elseif {[file exists $manx(manfull$w)]} {
		# cd into top of man hierarchy in case get .so's
		if {[string match */man?* $tmpdir]} {
			set topdir [file dirname $tmpdir]
		} else {set topdir $tmpdir}
		if [catch {cd $topdir}] {
			winstderr $wi "Can't cd into $topdir.  This is bad."
			return
		}
#puts stdout "\n\n\tcurrend dir [pwd]"
#puts stdout "manShowManFound\n\tcatfull = $manx(cat), manfull = $manx(manfull$w)"
		# try to save a nroff-formatted version?
		# check for H-P save directory
		if {[string match "*compress" $man(nroffsave)] && [file writable $manx(cat).Z]} {
			append manx(cat) ".Z"
		}
		if {[string match "on*" $man(nroffsave)]} {
			set saveerr ""

			# if .../catN unavailable, check Linux /var/catman alternative
			if {![file writable $manx(cat)] && [file writable "/var/catman"] && $fsstnd!=""} {
				set manx(cat) [file dirname $fsstnd]
			}

			# may need to create intermediate directories
			set idir ""
#puts "manx(cat) = $manx(cat)"
			foreach dir [split [string range $manx(cat) 1 end] "/"] {
#puts "idir = $idir, dir = $dir"
				if {![file exists $idir/$dir]} {
DEBUG {puts "\tmaking $idir/$dir"}
#					if {![file writable $idir]} {
#						winstderr $wi "$idir not writable when trying to mkdir $dir"
#						break
#					}
					if [catch "exec $man(mkdir) $idir/$dir" info] {
DEBUG {puts "\t  ERROR: $info"}
#						winstderr $wi $info; update idletasks
						set saveerr $info
						break
					}
				}
				append idir "/$dir"
			}

			if {$saveerr=="" && [file writable $manx(cat)]} {
				# same name as source file, different directory
				set path [set manx(catfull$w) $manx(cat)/$manx(man$w)]

				winstdout $wi "Saving copy formatted by nroff ..."; update idletasks
				if [catch {eval "exec [manManPipe $manx(manfull$w)] | $man(format) > $path"} info] {
					set saveerr "CAN'T SAVE: $info"
				} else {
					# if successfully saved formatted version, check on compressing it
					if {[string match "*compress" $man(nroffsave)]} {
						winstdout $wi "Compressing ..."; update idletasks
						if [catch "exec $man(compress) $manx(catfull$w)" info] {
							set saveerr "CAN'T COMPRESS:  $info"
							# set path -- keep same path
							# return -- ok to fall through
						} elseif {[file extension $manx(cat)]==".Z"} {	# H-P
							eval exec $man(mv) [glob $manx(catfull$w).$man(zglob)] $manx(catfull$w)
							set path $manx(catfull$w)
						} else {
							set path [set manx(catfull$w) [lfirst [glob $manx(catfull$w).$man(zglob)]]]
						}
					}
					set pipe [manManPipe $path]
				}
			}

			# if problem making nroff version, fall back
			if {$saveerr!=""} {
				after 20 winstdout $wi "{$saveerr}"
				set path $manx(manfull$w)
				set manx(catfull$w) ""
				set pipe "[manManPipe $path] | $man(format)"
			}

		# don't save formatted version
		} else {
			set path $manx(manfull$w)
			set manx(catfull$w) ""
			set pipe "[manManPipe $path] | $man(format)"
		}

	} elseif [catch {[file readlink $manx(manfull$w)]}] {
		winstderr $wi "$manx(manfull$w) is a symbolic link that points nowhere"
		return
	} else {
		winstderr $wi "$manx(manfull$w) not found"
		return
	}


	# got full file name, now show it
	set errflag 0
	set msg [expr [string match "*/*roff*" $pipe]?"Formatting and filtering":"Filtering"]
	winstdout $wi "$msg $manx(name$w) ..."; update idletasks


	append pipe " | $manx(rman) -f TkMan $man(subsect) $man(tables) $man(headfoot) $man(changeleft) $man(zaphy)"
DEBUG {puts stderr "pipe = $pipe"}

	# source should take a pipe argument: "source |$pipe"
	if [catch {set fid [open "|$pipe"]} info] {
#		winstderr $wi "Deep weirdness with $path.  Tell your sys admin."
		winstderr $wi "ERROR: $info"
DEBUG {puts "can't open pipe: $info"}
		return
	}

	manOpenText $w
	# want line at a time so can see first n lines quickly
	set time [time {
# plan A -- significately slower than plan B
#	while {[gets $fid line]!=-1} {eval $line}
# plan B -- shows first page, but slower than plan C
	while {![eof $fid]} {eval [gets $fid]}
# plan C - doesn't show first page quickly
#	eval [read $fid]
# plan D - quicker, but Perl 4 page uses 200K more memory! => so decided not quick enough!
#	set ctr 0
#	while {![eof $fid] && [incr ctr]<100} {eval [gets $fid]}
	# ... gobble rest as fast as possible
#	if {![eof $fid]} {eval [read $fid]}
	}]
DEBUG {puts "formatting time: $time"}
	if {$man(headfoot)!=""} {
		if {$manx(catfull$w)!=""} {
			set f $manx(catfull$w); set info "formatted"
		} else {set f $manx(manfull$w); set info "installed"}
		set fileinfo [eval "exec $man(ls) -l $f"]
		# wouldn't be so painful if had seconds=>date converter
		if {[regexp -nocase {(jan|feb|mar|apr|may|jun|jul|aug|sep|oct|nov|dec) (..) (.....)} $fileinfo all mon day year]} {
			set year [string trimleft $year]
#puts "got date for $f: *$mon* *$day* *$year*"
			set info "$f $info on [mon2Month $mon] $day"
			if {![string match "*:*" $year]} {append info ", $year"}
# {append info " at $year"}
			$t insert end "( $info )\n" sc
#puts "fileinfo=$fileinfo\nf=$f"
		}
	}
	manCloseText $w
	winstdout $wi ""

	if [catch {close $fid} info] {
#		winstderr $wi "Man page not installed properly, probably."
		winstderr $wi "ERROR: $info"
DEBUG {puts "can't close pipe: $info"}
		return
	}

	# if followed a .so link, restore initial man page name for history, shortcuts (but not highlights)
	# (is this the right policy decision?)
	if {$so} {
		set manx(manfull$w) $f0
		set manx(man$w) [file tail $f0]
		if {[regexp $man(zregexp) $manx(man$w)]} {set manx(man$w) [file rootname $manx(man$w)]}
		set manx(name$w) [file rootname $manx(man$w)]
#puts stderr "new status: $manx(manfull$w), $manx(man$w), $manx(name$w)"
	}

	manShowManFoundSetText $w

	cd $tmpdir
	manShowManStatus $w

	# for remote calls(?)
	return $manx(manfull$w)
}


proc manShowManFoundSetText {w} {
	global man manx

	set t $manx(out$w).show

	### after reading in text, build sections menu, count lines, show highlights
	# make sections menu
	set m [set mb $w.sections].m
	set ml [lsort -command "bytextposn $t " [$t mark names]]
	foreach i $ml {
		if ![string match "js*" $i] continue
		set pfx [expr {[string match "jss*" $i]?"   ":""}]
		set txt [$t get "$i linestart" "$i lineend"]
		$m add command -label [string tolower $txt] -command "$t yview $i"
	}
	if {$man(headfoot)!=""} {
		$m add separator
		$m add command -label "Header and Footer" -command "$t yview headfoot"
	}
	configurestate $mb [llength $ml]
	manMenuFit $w.sections.m

	scan [$t index end] "%d" linecnt 
	$w.search.cnt configure -text "$linecnt lines"


#	if {$manx(catfull$w)!=""} {set manx(hv$w) $manx(catfull$w)} {set manx(hv$w) $manx(manfull$w)}
	# always key highlights to name of source
	set manx(hv$w) $manx(manfull$w)

	manHighView $w

	focus $t
}


proc manManPipe {f} {
	global man

	if {[regexp $man(zregexp) $f] || [regexp $man(zregexp) [file dirname $f]]} {
		set pipe $man(zcat)
	} else {set pipe "cat"}

	return "$pipe $f"
}

proc manShowManStatus {w} {
	global man manx

	set t $manx(out$w).show; set wi $w.info

	### update status information

	# show section
	manSetSect $w $manx(manfull$w)

	# typein field
	set manx(typein$w) $manx(name$w)

	# history - save entire path
	set manx(history$w) \
		[lrange [setinsert $manx(history$w) 0 [list $manx(manfull$w)]] 0 [expr $man(maxhistory)-1]]
	# should do this as a postcommand, but that's too messy
	set m [set mb $w.history].m
	$m delete 0 last
	foreach i $manx(history$w) {
		if {[llength [lfirst $i]]>=2} {set l [lfirst $i]} {set l $i}
		if {![regexp {^[|<]} $l]} {
			set l [file tail $l]
			if [regexp $man(zregexp) $l] {set l [file rootname $l]}
		}
		$m add command -label $l -command "manShowMan $i {} $w"
	}
	configurestate $mb [llength $manx(history$w)]
	manMenuFit $m


	# hyperlinks
	set E 0
DEBUG {puts "LINKS"}
	set m [set mb $w.links].m
	catch {   foreach i [split $manx(links) /,.] {
DEBUG {puts $i}
		# have to split on spaces too (i.e., the foreach below) as sometimes references not separated by commas
		foreach j $i {
			if {[regexp {.+\([1-9lonp].*\)} $j]} {
DEBUG {puts "link: $j"}
				$m add command -label $j -command "manShowMan $j {} $w"
				incr E
			}
		}
	}}
	if {$manx(mode$w)=="man"} {
		configurestate $mb $E
	}
	manMenuFit $m


	# shortcuts
	manShortcutsStatus $w


	# whatis information -- find by scanning text
	winstdout $wi ""
	if {$man(whatwhere)} {
		winstdout $wi $manx(manfull$w)
	} else {
		scan [$t index end] %d n
		set n [max $n 20]
		for {set i 1} {$i<=$n} {incr i} {
			if {[regexp -- {- (.*)} [$t get $i.0 "$i.0 lineend"] all info]} {
				incr i
				while {[regexp { +(.*)} [$t get $i.0 "$i.0 lineend"] all spaces more]} {
					append info " $more"
					incr i
				}
				winstdout $wi "$info"
				break
			}
		}
	}
}



#--------------------------------------------------
#
# manShowText -- use searching, etc. facilities for non-man page text
#	 to use via `send', pass full path name of text file to show
#
#--------------------------------------------------

proc manShowText {f0 {w .man} {keep 0}} {
	global man manx

	set wi $w.info

# maybe want to use `file' to check for ASCII files
#	if {![file readable $f] || [file isdirectory $f]} {
#		winstdout $wi "Can't read $f"
#		return
#	}

	set t $manx(out$w).show

	if {[string match <* $f0]} {
		set f [fileexp [string range $f0 1 end]]
		if {[regexp $man(zregexp) $f]} {set f "|$man(zcat) $f"}
# {set f "|cat $f"}
	} else {set f [pipeexp $f0]}

	# strain out control characters and show nroff files
#	append f " | rman"

	manNewMode $w txt

	manOpenText $w
	if {[catch {
		set cnt 0
		set fid [open $f]
#		while {![eof $fid]} {eval [gets $fid]}
		while {![eof $fid]} {$t insert end [gets $fid]\n; incr cnt}
		close $fid
	}]} {manCloseText $w; winstderr $wi "Trouble reading $f0"; return}
	manCloseText $w
	if {!$keep} {pack forget $w.dups}

	if [file isfile $f] {cd [file dirname [glob $f]]}


	### update status information

	# could always save full path here, but that occupies too much screen real estate
	set manx(man$w) $f0
	set manx(num$w) X
	set manx(hv$w) $f
	set manx(manfull$w) $f0
	set manx(catfull$w) $f
	set manx(name$w) $f0
	set manx(links) {}
	set tmp $man(whatwhere)
	set man(whatwhere) 1
	manShowManStatus $w
	set man(whatwhere) $tmp

	$w.search.cnt configure -text "$cnt lines"
	manHighView $w
	focus $t
}



#--------------------------------------------------
#
# manApropos -- show `apropos' (`man -k') information, w/dups filtered out
#
#--------------------------------------------------

proc manApropos {name {w .man}} {
	global man manx mani

	if $manx(shift) { set manx(shift) 0; set w [manInstantiate] }
	set wi $w.info; set t $w.show

	if {$name==""} {set name $manx(man$w)}
	if {$name==""} {
		winstderr $wi "Type in keywords to search for"
		return
	}

	winstdout $wi "Apropos search for \"$name\" ..."; update idletasks

DEBUG {puts "manApropos: exec $man(apropos) $name $man(aproposfilter) 2>/dev/null"}
	if {[catch {set tmp [eval exec "$man(apropos) $name $man(aproposfilter) 2>/dev/null"]} info] || $tmp==""} {
		set mani(apropos,form) $info
#No apropos match for $name"
		set mani(apropos,cnt) 0
	} else {
		set mani(apropos,form) ""
		set cnt 0
		foreach line [split $tmp "\n"] {
			# zap formatting codes if erroneously given roff source
			regsub "^\\.\[^ \t\]+" $line "" line
			# normalize spacing between names and descriptions to single tab
			regsub "\[ \t\]+- " $line "\t - " line
			append mani(apropos,form) $line "\n"

			incr cnt
		}

		set mani(apropos,cnt) $cnt
		set manx(yview,apropos) 0
	}

	manShowSection $w apropos
}



#--------------------------------------------------
#
# manGlimpse -- full text search
#
#--------------------------------------------------

proc manGlimpse {name {w .man}} {
	global man manx mani sbx env STOP

	if $manx(shift) {set manx(shift) 0; set w [manInstantiate]}
	set t $manx(out$w).show; set wi $w.info

	# set name to search for and name to show
	if {$name==""} {set name $manx(man$w)}
	if {$name==""} {
		winstderr $wi "Type in regular expression for full text search"
		return
	}
	set showname $name
	# escape out semicolons meant for Glimpse so Tcl doesn't parse them as commands separators
	regsub -all {([^\]);} $name {\1\;} name

	# set options
	# X DO NOT put -z option here.  unneeded and causes errors when pages are compressed
	# => au contraire, DO put -z in as Glimpse interrogates compressed files to verify matches
	set opts "-lyz"
	set casesen $man(regexp,case); if {$casesen==-1 && [string tolower $name]!=$name} {set casesen 1}
	if {!$casesen} {append opts "i"}
	if {$man(maxglimpse)!="none"} {append opts " -L $man(maxglimpse)"}
	set redirect ""
	# HACK: -N spits out blocks matches to stderr, which is an error to Tcl
	if [regexp { -[^ ]*N[^ ]* } "$man(glimpse) $name"] {append redirect "2>/dev/null"}

	set STOP 0
	cursorBusy

	set foundList ""
	set errorList ""
	# would be considerably(?) more efficient if Glimpse could handle a list of directories
	# to search for matches, rather than multiple exec's
	foreach d [concat $manx(paths) $manx(glimpsestrays)] {
		# index over currently selected paths, and (always) stray cats
		if {$d!=$man(glimpsestrays) && !$man($d)} continue
		if ![file readable $d/.glimpse_index] {
# this reported at statup
#			append errorList "$d: no Glimpse index files\n"
			continue
		}
		winstdout $wi "Glimpsing for \"$showname\" in $d ..."; update
DEBUG {puts "$man(glimpse) $opts -H $d $name"}
		if {$STOP} {set STOP 0; break}
		# silently skip over problems (like no .glimpse_* files)
		if ![catch {set matches [eval exec -keepnewline "$man(glimpse) $opts -H $d $name $redirect"]} info] {
			 append foundList $matches
		} else {
			append errorList "can't glimpse $d: $info\n"
			winstderr $wi "error with glimpsing: $info"
		}
	}
	winstdout $wi ""
	cursorUnset

	set found [llength $foundList]; set error [string length $errorList]
	if {!$found && !$error} {
		winstderr $wi "$name not found in full text search"
	} else {
		set mani(glimpse,form) ""

		if $error {
			append mani(glimpse,form) "Errors while Glimpsing\n\n" $errorList "\n\n"
		}

		foreach i [lsort -command manSortByName $foundList] {
			append mani(glimpse,form) "$i\n"
		}
		set mani(glimpse,cnt) $found
		set manx(yview,glimpse) 0

		# seed regexp and isearch strings
		set manx(search,string$w) [tr [tr [llast $name] ";" ".*"] "," "|"]
		set sbx(lastkeys-old$t) [llast $name]

		manShowSection $w glimpse
	}
}


proc manGlimpseIndex {{w .man}} {
	global man manx mani env

	manNewMode $w super
	set t $manx(out$w).show; set wi $w.info

	winstdout $wi "Rebuilding Glimpse database ... "
	manOpenText $w; update idletasks
	# index over all paths, including stray cats
	set indexdirs [concat $manx(paths) $manx(glimpsestrays)]
	set cnt [llength $indexdirs]; set cur 1
	set foneup 0

	foreach dir $indexdirs {
		$t insert end "Working on $dir ($cur of $cnt)\n\n" b; $t see end; update idletasks

		set dirs $mani($dir,dirs)
		set gzt ".glimpse_filters"
		set gf "$dir/.glimpse_filenames"
		set gz "$dir/$gzt"
		set gfe [expr [llength [glob -nocomplain $dir/.glimpse_{filenames,index}]]==2]


		# see if index is out of date
		set outofdate [expr {!$gfe || [file size $gf]==0 || ([file exists $gz] && [file mtime $gz]>[file mtime $gf])}]
		if {!$outofdate} {
			set gtime [file mtime $gf]
			foreach d $dirs {
				if {[file mtime $d]>$gtime} {set outofdate 1; break}
			}
		}
		if {!$outofdate} {
			$t insert end "Glimpse index still current.\n" indent

			set foneup 1
			# could use perl-style continue expression here
			incr cur; $t insert end "\n\n"
			continue
		}


		# directory writable?
		if {![file writable $dir]} {
			$t insert end "Glimpse index out of date but directory not writable" indent
			if {$gfe} {
				$t insert end " ... but old Glimpse files found\n" indent
				$t insert end "Full text seaching available here using existing files.\n" indent
			} else {
				$t insert end " ... and Glimpse files not found\n" indent
				$t insert end "No full text searching available here.\n" {indent bi}
			}

			incr cur; $t insert end "\n\n"
			continue
		}


		# see if .glimpse_filters file needed, and if so make one
		# (but don't overwrite any existing .glimpse_filters)
		if ![file exists $gz] {
			set fcat [expr [lsearch -regexp $dirs {/cat[^/]*$}]!=-1]
#|/catman/
			set fhp [expr [lsearch -regexp $dirs {\.Z$}]!=-1]
			set fz 0
			foreach d $dirs {
				# cd into directory so get the short file names (important for /usr/man!)
				cd $d
				if {[lsearch -regexp [glob -nocomplain *] $man(zregexp)]!=-1} {set fz 1; break}
			}

#			$t insert end "* * * create $gzt file here: fcat=$fcat, fhp=$fhp, fz=$fz\n"
			set fid [open $gz "w"]
			# # # # # # # # # # # # # # # # # # # # # # # # # # # # #
			# create file according to man(compress) and man(zglob) #
			# # # # # # # # # # # # # # # # # # # # # # # # # # # # #
			if $fhp {puts $fid "*.Z/*\tzcat <"}
			if {$fz} {
				set zcat [file tail [lindex $man(zcat) 0]]
				switch -glob -- $zcat {
					gz* {puts $fid "*.z\t$man(zcat)\n*.Z\t$man(zcat)\n*.gz\t$man(zcat)"}
# would like to do this
#					gz* {puts $fid "*.{z,Z,gz}\t$man(zcat)"}
					default {
						# works for zcat, pcat and (one hopes) anything else to come
						# (string trimright because of HP "zcat < ")
						puts $fid "*.$man(zglob)\t[string trimright $man(zcat) { <}]"
					}
				}
			}
			# strip AFTER decompression
			if $fcat {puts $fid "*/cat*/*\trman <"}
			close $fid
		}


		### try to index or re-index directory
		if [catch {set fid [open "|$man(glimpseindex) -z -H $dir $dirs"]} info] {
			# other problem ... like what?
DEBUG {puts "error on: $man(glimpseindex) -z -H $dir $dirs]"}
			$t insert end "$info\n" bi
			catch {close $fid}
		} else {
DEBUG {puts "$man(glimpseindex) -z -H $dir $dirs"}
			set blankok 0
			while {![eof $fid]} {
				gets $fid line
				if {![regexp {(^This is)} $line] && ($line!="" || $blankok)} {
					$t insert end "$line\n" tt; $t see end; update idletasks
					set blankok 1
				}
			}
			if [catch {close $fid} info] { $t insert end "ERRORS\n" {indent bi} $info indent2 "\n" }

			if {[file size $gf]==0} {
				$t insert end "No files could be indexed.  No full text searching available here.\n" {indent bi}
				if [file exists $gz] {
					$t insert end "Try checking your $gzt file in $dir.  If $gzt wasn't created by TkMan, try deleting it and letting TkMan create one of its own.\n" indent
				}
			} else {
				# unless index is in home directory, make it sharable (readable) by all
				if ![string match "$env(HOME)*" $dir] {
					catch { eval exec $man(chmod) a+r [glob $dir/.glimpse_*] }
				}
			}
		}

		incr cur
		$t insert end "\n\n"
	}

	if {$foneup} {
		$t insert end "\nTo force re-indexing of directories that TkMan claims are current, remove all Glimpse index files in that directory, as with `rm <dir> .glimpse_*'.\n" i
	}

	$t see end
	manCloseText $w
	winstdout $wi ""
}


#--------------------------------------------------
#
# manPrint -- kill trees
#
#--------------------------------------------------

proc manPrint {w} {
	global man manx winout

	set t $w.show; set wi $w.info
# can't get here unless man page
#	if {$manx(mode$w)!="man" && $manx(mode$w)!="txt"} {
#		winstderr $wi "TkMan only prints man pages."
#		return
#	}

	set f [string trim $manx(manfull$w)]
	if {$f=="" || ![file exists $f]} return
	set name [file rootname [file tail $f]]; set sect [file extension $f]
	if {[regexp $man(zregexp) $f]} {set sect [file extension $name]; set name [file rootname $name]}
	if {$sect==""} {set sect [string index [file dirname $f] 3]}

	set tmp $winout(lastMessage$wi)
	winstdout $wi "Printing $f ..."; update idletasks
	# need to cd in case of trying to print .so pages
	set tmpdir [pwd]
	set topdir [file dirname $f]
	set printpipe $man(print)
	if {[regexp -- $man(catsig) $topdir]} {
		set printpipe $man(catprint)
		if {[tk_dialog .dialog "NO GUARANTEES" "No troff source.  Try to reverse compile cat-only page?" \
				"" 1 No Yes]} {
			set printpipe "$manx(rman) -f roff $man(changeleft) $man(tables) $man(subsect) -n $name -s $sect $man(zaphy) | $man(print)"
		}
	}
	if {[regexp $man(catsig) $topdir] || [string match */man?* $topdir]} {
		set topdir [file dirname $topdir]
	}

	# try to move into $topdir, but don't complain if can't because it may not be necessary
	catch {cd $topdir}
DEBUG {puts stderr "print pipe = [manManPipe $f] | $printpipe"}
	eval exec [manManPipe $f] | $printpipe
	winstdout $wi $tmp
	cd $tmpdir
}



#--------------------------------------------------
#
# manHelp -- dump help text that's "compiled" offline
#
#--------------------------------------------------

proc manHelp {w} {
	global man manx

	set t $w.show; set wi $w.info

	manNewMode $w help
	set manx(manfull$w) "help"
	set manx(hv$w) help

	manOpenText $w
	# put in help first so marks set correctly (they stay correct subsequently as they float)
	manHelpDump $t
	# fixups
	$t tag remove h1 1.0 "1.0 lineend"; $t tag add title 1.0 "1.0 lineend"
	$t delete 2.0
	$t delete 7.10 7.14; $t insert 7.10 "\251"; $t tag add symbol 7.10
	foreach bm {icon face} {
		$bm configure -foreground black -background white
		label $t.$bm -image $bm
	}
	$t window create 2.0 -window $t.icon -padx 8 -pady 8
	$t mark set insert "addresses1+2lines lineend"
	$t insert insert "\t"
	$t window create insert -window $t.face -align bottom -padx 8 -pady 8

	# now add to opening screen
	if [string length $manx(warnings)] {
		$t insert 1.0 $manx(warnings)\n\n
		$t insert 1.0 "Warnings\n\n" b
	}

	$t insert 1.0 $manx(updateinfo)

	manHighView $w

	manCloseText $w
	update idletasks


	# set up sections from marks
	# do this first as marks set by absolute positions
	set m $w.sections.m
	foreach i [lsort -command "bytextposn $t " [$t mark names]] {
		if {![string match "*1" $i] && ![string match "*2" $i]} continue
#puts "mark => $i"
		set indent ""; if [string match "*2" $i] {set indent "   "}
		set txt [$t get "$i linestart" "$i lineend"]
		$m add command -label "$indent$txt" -command "$t yview $i"
	}
	manMenuFit $m


	set seealso {rman man(1) man(7) catman(8) xman(1) Tcl text regexp bind options}
	if {$man(glimpse)!=""} {lappend seealso "glimpse"}
	set m $w.links.m
	foreach i $seealso {
		$m add command -label $i -command "manShowMan $i {} $w"
	}
	manMenuFit $m

	scan [$t index end] %d eot
	$w.search.cnt configure -text "$eot lines"

	set manx(name$w) "help"
	after 1 "winstdout $wi \"TkMan v$manx(version) of $manx(date)\""
}

proc bytextposn {t a b} {
	set ap [$t index $a]; set bp [$t index $b]
	if {$ap<$bp} {set cmp -1} elseif {$ap>$bp} {set cmp 1} else {set cmp 0}
	return $cmp
}


#--------------------------------------------------
#
# manKeyNav -- keyboard-based navigation and searching
#    calls out to searchbox module
#
#--------------------------------------------------

proc manKeyNav {w m k} {
	global man manx

	set t $w.show; set wi $w.info

	set firstmode [expr {$manx(mode$w)=="section" || $manx(mode$w)=="apropos"}]
	set casesen [expr $firstmode?1:$man(incr,case)]

	set fFound [searchboxKeyNav $m $k $casesen $t $wi $firstmode]
#	if {!$fFound && $firstmode} {set fFound [searchboxKeyNav $m $k 0 $t $wi $firstmode]}

	return $fFound
}



#--------------------------------------------------
#
# manPreferences -- graphical interface to many values stored in startup file
#
#--------------------------------------------------

proc manPreferencesMake {{w0 ""}} {
	global prefedit manx man bozo
# don't do global man here

	set w .prefs
	if {[winfo exists $w]||$w0==""} {return $w}

	toplevel $w
	wm geometry $w $prefedit(geom-prefs)
	wm title $w "Preferences"
	wm withdraw $w

	set f [frame $w.pages]
	foreach i {Fonts Colors See Icon Misc} {
		set il [string tolower $i]
		radiobutton $f.$il -text $i -command manPreferences -variable manx(prefscreen) -value $il
	}
	pack $f.fonts $f.colors $f.see $f.icon $f.misc -side left -fill x -padx 4

	frame $w.sep1 -height 2 -background $prefedit(guifg)


	### fonts
	set g [frame $w.[set group "fonts"]]

	# fonts: gui, file, errors -- family, size
	foreach i {{gui Interface} {text "Text display"} {vol "Volume listings"}} {
		set var [lfirst $i]; set txt [lsecond $i]
		lappend manx(vars-$group) $var-family $var-style $var-points
		set f [frame $g.font$var]
		label $f.l -text $txt
		[eval tk_optionMenu $f.family prefedit($var-family) $man(families)] configure -tearoff no
		[eval tk_optionMenu $f.style prefedit($var-style) $manx(styles)] configure -tearoff no
		[eval tk_optionMenu $f.points prefedit($var-points) $manx(sizes)] configure -tearoff no
		pack $f.l -side left -fill x
		pack $f.style $f.points $f.family -side right -padx 2
	}

#	if {[llength $man(dpi-values)]>1}
	# screen dpi: *, 75, 100
	set f [frame $g.dpi]
	label $f.l -text "Screen dots per inch (DPI)"
	[eval tk_optionMenu $f.dpi prefedit(dpi) $prefedit(dpis)] configure -tearoff no
	lappend manx(vars-$group) "dpi"
	pack $f.l -side left -fill x
	pack $f.dpi -side right

	pack $g.fontgui $g.fonttext $g.fontvol $g.dpi -fill x -pady 3 -padx 4


	### colors
	set g [frame $w.[set group "colors"]]

	foreach i {{text "Text"} {gui "Interface"} {butt "Buttons"} {active "Active Regions"}} {
		set var [lfirst $i]; set txt [lsecond $i]
		lappend manx(vars-$group) ${var}fg ${var}bg
		set f [frame $g.$var]
		label $f.l -text $txt
		foreach j {{fg "foreground"} {bg "background"}} {
			set jvar [lfirst $j]; set jtxt [lsecond $j]
			if {$jvar=="fg"} {set jopp "bg"} {set jopp "fg"}
			set mb $f.$var$jvar
			[set m [eval tk_optionMenu $mb prefedit($var$jvar) $man(colors)]] configure -tearoff no
			# when monochrome, keep foreground and background colors opposites!
			if {$manx(mono)} {
				foreach k $man(colors) {
					set copp [lindex $prefedit(colors) [expr 1-[lsearch $prefedit(colors) $k]]]
					$m entryconfigure $k -command "set prefedit($var$jopp) $copp; set prefedit($var$jvar) $k"
				}
			}
		}
		pack $f.l -side left -fill x
		pack $f.${var}bg [label $f.${var}on -text "on"] $f.${var}fg -side right -padx 4
	}

	foreach i {{manref f "Man page references"} {isearch b "Incremental search hits"}
				{search b "Regexp search hits"} {highlight b "Highlights"}} {
		set var [lfirst $i]; set fb [lsecond $i]; set txt [lthird $i]
		lappend manx(vars-$group) $var
		set f [frame $g.$var]
		label $f.l -text $txt

		[set m [eval tk_optionMenu [set mb $f.$var] prefedit($var) $manx(highs)]] configure -tearoff no
			foreach k $manx(highs) {
				if {[lsearch $man(colors) $k]==-1} {set val $k} \
				else {if {$fb=="f"} { set val "-foreground [list $k]"} { set val "-background [list $k]" } }
				$m entryconfigure $k -command "set prefedit($var) [list $val]"
			}
		pack $f.l -side left -fill x
		pack $mb -side right -padx 4
	}

	pack $g.text $g.gui $g.butt $g.active $g.manref $g.isearch $g.search $g.highlight \
		-fill x -expand yes -pady 3 -padx 4


	### See
	set g [frame $w.[set group "see"]]

	foreach i {{headfoot "Show header, footer, date at bottom"} {scrollbarside "Scrollbar side"}
				{whatwhere "Information bar shows"} {textboxmargin "Text box margin"}
				{volcol "Width of columns in Volumes list"}
				{high,vcontext "Back context for Highlights jump"}
				{strictmotif "Strict Motif behavior"} 
				{subvols "Subvolumes as submenus in Volumes"} 
				{apropostab "Tab stop in apropos list"}} {
		set var [lfirst $i]; set txt [lsecond $i]
		lappend manx(vars-$group) $var
		set f [frame $g.$var]
		label $f.l -text $txt
		[set m [eval tk_optionMenu $f.high bozo($var) $manx(${var}-t)]] configure -tearoff no
			set j 0
			foreach mv $manx(${var}-v) {
				$m entryconfigure $j -command "set prefedit($var) [list $mv]"
				incr j
			}
			trace variable prefedit($var) w manPrefBozo
		pack $f.l -side left -fill x
		pack $f.high -side right
	}

	pack $g.headfoot $g.subvols $g.high,vcontext $g.volcol $g.apropostab $g.whatwhere $g.scrollbarside $g.textboxmargin $g.strictmotif \
		-fill x -pady 3 -padx 4



	### icon-related
	set g [frame $w.[set group "icon"]]

	foreach i {{iconify "Iconify on startup"} {updateicon "... or reflect current page in iconname"}} {
		set var [lfirst $i]; set txt [lsecond $i]
		lappend manx(vars-$group) $var
		set f [frame $g.$var]
		label $f.l -text $txt
		[set m [eval tk_optionMenu $f.high bozo($var) $manx(${var}-t)]] configure -tearoff no
			set j 0
			foreach mv $manx(${var}-v) {
				$m entryconfigure $j -command "set prefedit($var) [list $mv]"
				incr j
			}
			trace variable prefedit($var) w manPrefBozo
		pack $f.l -side left -fill x
		pack $f.high -side right
	}

	foreach i {{iconname "Name when iconified..."}
				{iconbitmap "Path name of icon bitmap"} {iconmask "Path name of icon mask"}
				{iconposition "Icon position (+|-)x(+|-)y"}} {
		set var [lfirst $i]; set txt [lsecond $i]
		lappend manx(vars-$group) $var
		set f [frame $g.$var]
		label $f.l -text $txt
		entry $f.e -textvariable prefedit($var) -relief sunken

		pack $f.l -side left -fill x
		pack $f.e -side right
	}
	set ring {iconname iconbitmap iconmask iconposition}; set ringl [llength $ring]
	for {set i 0} {$i<$ringl} {incr i} {
		set wig $g.[lindex $ring $i].e
		foreach k {Tab Return} { bind $wig <KeyPress-$k> "focus $g.[lindex $ring [expr ($i+1)%$ringl]].e"; break }
		bind $wig <Shift-KeyPress-Tab> "focus $g.[lindex $ring [expr ($i-1)%$ringl]].e; break"
	}

	# file completion for bitmap names
	foreach wig {iconbitmap iconposition} {
		set e $g.$wig.e
		bind $e <KeyPress-Escape> "manFilecompleteLocal $e"
	}

	pack $g.iconify $g.iconname $g.updateicon $g.iconbitmap $g.iconmask $g.iconposition \
		-fill x -pady 3 -padx 4


	### miscellaneous
	set g [frame $w.[set group "misc"]]

	foreach i {{nroffsave "Cache formatted (nroff'ed) pages"}
				{subsect "Parse man page subsections"}
				{tables "Aggressive table parsing"}
				{recentdays {"Recent" volume age (in days)}}
				{maxhistory "Maximum length of history list"}
				{maxglimpse "Maximum Glimpse hits (per man hierarchy)"}
				{zaphy "Prevent hyphenation (silly)"}} {
		set var [lfirst $i]; set txt [lsecond $i]
		lappend manx(vars-$group) $var
		set f [frame $g.$var]
		label $f.l -text $txt
		[set m [eval tk_optionMenu $f.high bozo($var) $manx(${var}-t)]] configure -tearoff no
			set j 0
			foreach mv $manx(${var}-v) {
				$m entryconfigure $j -command "set prefedit($var) [list $mv]"
				incr j
			}
			trace variable prefedit($var) w manPrefBozo
		pack $f.l -side left -fill x
		pack $f.high -side right
	}

	pack $g.nroffsave $g.subsect $g.maxhistory $g.recentdays $g.maxglimpse $g.tables $g.zaphy \
		-fill x -pady 3 -padx 4


	# buttons
	frame $w.bsep -relief sunken -height 2 -background $prefedit(guifg)
	set f [frame $w.butts]
	button $f.ok -text "OK" -padx 6 -command "grab release $w; wm withdraw $w; manPreferencesSet"
	button $f.apply -text "Apply" -command "manPreferencesSet"
	button $f.cancel -text "Cancel" -command "
		grab release $w; wm withdraw $w
		manPreferencesGet cancel; manPreferencesSet
	"
	button $f.default -text "Defaults" -command "manPreferencesGet default"
	pack $f.ok $f.apply $f.default $f.cancel -side right -padx 4


	pack $w.pages $w.sep1 $w.bsep $w.butts \
		-side top -fill x -pady 3 -padx 4

	return $w
}

proc manPrefBozo {array var op} {
	global prefedit manx bozo
	set bozo($var) [lindex $manx($var-t) [lsearch $manx($var-v) $prefedit($var)]]
}


proc manFilecompleteLocal {t} {
	set line [$t get]
	set fc [filecomplete $line]
	set ll [llength $fc]

	# no matches returns
	if {!$ll} {
		bell
		return
	}

	# otherwise show longest valid name (longest common prefix determined by filecomplete)
	$t delete 0 end
	$t insert 0 [lfirst $fc]
	$t icursor end
	$t xview moveto 1
}


proc manPreferencesGet {{cmd "fill"}} {
	global man manx default prefedit cancel curedit

	if {$cmd=="fill"} {
		foreach i [array names default] {set prefedit($i) [set curedit($i) [set cancel($i) $man($i)]]}
	} elseif {$cmd=="default"} {
		foreach i $manx(vars-$manx(prefscreen)) {set prefedit($i) $default($i)}
	} elseif {$cmd=="cancel"} {
		foreach i [array names default] {set prefedit($i) $cancel($i)}
	} elseif {$cmd=="man"} {
		foreach i [array names default] {set man($i) $prefedit($i)}
	} elseif {$cmd=="curedit"} {
		foreach i [array names default] {set curedit($i) $prefedit($i)}
	}
}

set manx(prefscreen) "fonts"
set manx(oldprefscreen) ""
proc manPreferences {{screen ""}} {
	global manx

	# show right grouping
	set w [manPreferencesMake bozo]
	raise $w
	if {$screen==""} {set screen $manx(prefscreen)} {set manx(prefscreen) $screen}
	set prev $manx(oldprefscreen)

	if {$screen!=$prev} {
		if {$prev!=""} {
			pack forget $w.$prev
#			$w.pages.$prev configure -relief raised
		}

		pack $w.$screen -after $w.sep1 -fill x
#		$w.pages.$screen configure -relief sunken

		set manx(oldprefscreen) $screen
	}

	if ![winfo ismapped $w] {
		manPreferencesGet fill
		wm deiconify $w; grab set $w
	}
}

proc manPresDefaultsSet {} {
	global man font

	# fonts & colors
	foreach i {{gui ""} {butt "Button."} {butt "Menubutton."} {butt "Radiobutton."} \
				{butt "Checkbutton."} {text "Text."}} {
# {gui "Scrollbar."}} {
# {txt "Entry."}
		set var [lfirst $i]; set txt [lsecond $i]
		if [info exists man(${var}-family)] {
			option add Tkman*${txt}Font \
				[spec2font $man(${var}-family) $man(${var}-style) $man(${var}-points)] 61
		}
		option add Tkman*${txt}Foreground $man(${var}fg) 61
		option add Tkman*${txt}Background $man(${var}bg) 61
#puts "option add ...$txt... $man(${var}fg) on $man(${var}bg)"
	}

	option add Tkman*activeForeground $man(activefg) 61
	option add Tkman*activeBackground $man(activebg) 61
	option add Tkman*highlightBackground $man(activebg) 61

	option add Tkman*selectColor $man(buttfg) 61

	set font(pro) [spec2font $man(text-family) $man(text-style) $man(text-points)]
	set font(mono) [spec2font "Courier" $man(text-style) $man(text-points) "s"]
	set font(vol) [spec2font $man(vol-family) $man(vol-style) $man(vol-points)]
	if {[string match "*Courier*" $man(currentfont)]} {
		set man(currentfont) $font(mono)
	} else {set man(currentfont) $font(pro)}
}


# reconfigure screen based on new preferences information
proc manPreferencesSet {} {
	global man manx prefedit curedit default tag

	set change 0
	foreach i [array names default] {
		if {$curedit($i)!=$prefedit($i)} {
			set change 1
			break
		}
	}
	if !$change return

	# make temporary permanent
	manPreferencesGet man
#	manGeometry get -- done just before quit

	# # # set keybindings--later

	# fonts -- text, gui (main and preferences windows)
	manPresDefaultsSet
	resetfonts [spec2font $man(gui-family) $man(gui-style) $man(gui-points)]
	resetcolors

	# update text tags and other .man* bits
	foreach w [lmatches ".man*" [winfo children .]] {manPreferencesSetMain $w}

#	manGeometry set
	manPreferencesGet curedit
}


proc manPreferencesSetMain {w} {
	global man manx font curedit tk_strictMotif

	if ![string match ".man*" $w] return

	# icon-related
	# ... need to reference man() to get new values, but manx() has command line options
	foreach i {iconname iconposition iconbitmap iconmask} {
		if {$man($i)!=$curedit($i)} {set manx($i) $man($i)}
	}
	set num [string range $w 4 end]
	# have option to show current man page name instead? -- would need to constantly update this
	if {$num==""} {set name $manx(iconname)} {set name "$manx(iconname) - $num"}
	wm iconname $w $name
	if {[regexp $manx(posnregexp) $manx(iconposition) all x y]} {
		wm iconposition $w $x $y
	}
	# everybody shares same icons
	foreach i {iconbitmap iconmask} {wm $i $w ""}
# iconwindow
	foreach i {iconbitmap iconmask} {
		if {$manx($i)!=""} {wm $i $w @$manx($i)}
	}
if 0 {
	if {$manx(iconbitmap)=="(default)"} {
		set iw .iconwindow
		if ![winfo exists $iw] {toplevel $iw; label $iw.l -image image1; pack $iw.l}
		wm iconwindow $w $iw
	}
}

	# random bits

	$w.mono configure -onvalue $font(mono) -offvalue $font(pro)
	pack $w.v -side $man(scrollbarside)
	set tk_strictMotif $man(strictmotif)
	$w.dups configure -font [spec2font "symbol" "normal" $man(gui-points)]
	$w.mono configure -font [spec2font "Courier" $man(gui-style) $man(gui-points)]
	foreach i [list $w.occ.m $w.paths.m $w.occ.m.m2 $w.occ.m.m3] {
		$i configure -selectcolor $man(guifg)
	}

	# the scrollbar is an oddball
	$w.v configure -troughcolor $man(guibg)
	$w.v configure -background [expr {$man(buttbg)!=$man(guibg)?$man(buttbg):$man(guifg)}]

	# text widget fonts and tags
	set t $w.show
	$t configure -padx $man(textboxmargin) -pady $man(textboxmargin)
	if {$manx(mode$w)=="section"} {set newtextfont $font(vol)} {set newtextfont $man(currentfont)}
	$t configure -font $newtextfont
	$t configure -tabs $man(volcol)
	$t tag configure apropos -tabs $man(apropostab) -lmargin2 $man(apropostab)

	$t tag configure sel -foreground "$man(textbg)" -background "$man(textfg)"

	foreach v $manx(tags) {
#puts "$t => [winfo class $t]"
		$t tag configure $v -font "" -foreground "" -background "" -underline no
		set change ""; set newfont 0
		set fam $man(text-family); set sty $man(text-style); set poi $man(text-points); set poi2 "m"
		foreach g $man($v) {
			switch -exact -- $g {
				normal {}
				underline {append change " -underline yes"}
				reverse {append change " -foreground {$man(textbg)} -background {$man(textfg)}"}
				italics { set sty $g; set newfont 1 }
				bold -
				bold-italics {
					set sty $g; set poi2 "s"; set newfont 1
				}
				mono { set fam "Courier"; set poi2 "s"; set newfont 1 }
				symbol { set fam "Symbol"; set sty "normal"; set newfont 1 }
				small -
				medium -
				large {
					set poi $g; set newfont 1
				}
				s -
				m -
				l {
					set poi2 $g; set newfont 1
				}
				left -
				right -
				center {
					append change " -justify $g"
				}
				default {append change " " [list $g]}
			}
		}
		if {$newfont} {append change " -font \"[spec2font $fam $sty $poi $poi2]\""}
#puts "change = $change"
		eval $t tag configure $v $change
	}
	$t tag raise sel


	if {$curedit(subvols)!=$man(subvols)} {manMakeVolList $w}
}


proc resetfonts {font {w .}} {
	# do current window first--may cancel reconfig without examining children
	if ![catch {set oldfont [$w configure -font]}] {
		if {$oldfont==$font} return
		$w configure -font $font
	}

	# recurse
	foreach c [winfo children $w] {
		resetfonts $font $c
	}
}

proc resetcolors {{w .}} {
	global man curedit

	set c [winfo class $w]
	set g "gui"; if {$c=="Text"} {set g "text"} elseif {[string match "*utton" $c]} {set g "butt"}
#||$c=="Entry"
	set foreground [set selector [set insertbackground $man(${g}fg)]]
	set background $man(${g}bg)
	set ofg $curedit(${g}fg)
	set obg $curedit(${g}bg)

#puts "checking $w, class $c"
	foreach i {foreground background insertbackground selector} {
		if ![catch {set color [$w cget -$i]}] {
			 if {$color==$ofg} {$w configure -$i $foreground} \
			 elseif {$color==$obg} {$w configure -$i $background}
		}
	}

	set activeforeground $man(activefg)
	set activebackground $man(activebg)
	set highlightbackground $activebackground
	foreach i {activeforeground activebackground highlightbackground} {
		catch {$w configure -$i [set $i]}
	}

	# recurse
	foreach c [winfo children $w] {
		resetcolors $c
	}
}


proc spec2font {{family "times"} {style "normal"} {points "medium"} {size "m"}} {
	global man manx

	set dpi $man(dpi)
#puts -nonewline "$family + $style + $points ( $size ) + $dpi => "
	switch -exact -- $style {
		normal {set style "medium-r"}
		bold {set style "bold-r"}
		italics {
			if [regexp -nocase $manx(xmono) $family] {set style "medium-o"} {set style "medium-i"}
		}
		bold-italics {
			if [regexp -nocase $manx(xmono) $family] {set style "bold-o"} {set style "bold-i"}
		}
		default {puts stderr "nonexistent style: $style"; exit 1}
	}

	# specify s,m,l within small,medium,large; or set absolute point size
	if {[set pts [lsearch $manx(sizes) $points]]!=-1} {
		set p "[lindex [lrange $manx(pts) $pts end] [lsearch {s m l} $size]]"
	} else {set p $points}
	append p "0"

	set font "-*-$family-$style-normal-*-*-$p-$dpi-$dpi-*"
#puts $font

	return $font
}


#--------------------------------------------------
#
# manSave -- manage merging with old config file
# if passed name of save file, could put this into utils
#
#--------------------------------------------------

proc manSave {} {
	global man manx env

	if {$manx(savegeom)} {set man(geom) [wm geometry .man]}
	set w [manPreferencesMake]
	if [winfo exists $w] {set man(geom-prefs) [geom2posn [wm geometry $w]]}

	set nfn $manx(startup)
	set ofn $env(HOME)/.tkman-bkup

	if {![file exists $nfn] || [file writable $nfn]} {
		if {[file exists $nfn]} {eval exec $man(cp) $nfn $ofn}
		if [catch {set fid [open $nfn w]}] {
			winstderr .man.info "$nfn is probably on a read-only filesystem"
			return
		}
		foreach p [info procs *SaveConfig] {eval $p $fid}
		puts $fid "manDot\n"
		puts $fid $manx(userconfig)

		if {[file exists $ofn]} {
			set ofid [open $ofn]
			set p 0
			while {[gets $ofid line]!=-1} {
				if {$p} {puts $fid $line} \
				elseif {$manx(userconfig)=="$line"} {set p 1}
			}
		}
		close $fid
	}

	# don't delete ~/.oldtkman
}



#--------------------------------------------------
#
# manSaveConfig -- dump persistent variables into passed file id
#
#--------------------------------------------------

proc manSaveConfig {fid} {
	global man manx high default

# if only persistent stuff in man array,
# could have general SaveConfig in utils.tcl

	# write out preamble
	puts $fid "#\n# TkMan v$manx(version)\n#\n"
# insert $env(USER)?

	set preamble {
		Elements of the man array control many aspects of operation.
		Some, but not all, user-controllable parameters are available
		in the Preferences panel.  All parameters are listed below.
		Those that are identical to their default values are commented
		out (preceded by \"#\") so that changes in the defaults will propagate nicely.
		If you want to override the default, uncomment it and change the value
		to its new, perisistent setting.
	}
	foreach line [split [linebreak $preamble] "\n"] {
		puts $fid "# $line"
	}
	puts $fid ""


	# save miscellaneous variables

	# write out man(), commenting out if same as corresponding default()
	# maybe iterate through default array ==> no!  won't pick up man(/<directory>)'s
	foreach i [lsort [array names man]] {
		if {[info exists default($i)]} {
			if {$default($i)==$man($i)} {set co "#"} {set co ""}
			puts $fid "${co}set [list man($i)] [tr [list $man($i)] \n \n$co]"
		} elseif {[string match "/*" $i]} {puts $fid "set man($i) $man($i)"}
	}

	puts $fid "\n\n#\n# Highlights\n#\n"
#	puts $fid "# format: time, start/end pairs for use by text widget"
	foreach i [lsort [array names high]] {
		puts $fid "set [list high($i)] [list $high($i)]"
	}

	puts $fid "\n"
}



#--------------------------------------------------
#
# Startup initialization and validity checks
#
#--------------------------------------------------


# after reading .tkman variables but before executing code

proc manDot {} {
	global manx

	manManManx

	manPresDefaultsSet
	# make window here so ~/.tkman commands can manipulate it without `after'
	toplevel .man -class TkMan
	manPreferencesGet fill

	set manx(manDot) 1
}

proc manManManx {} {
	global man manx
	# these get set to man counterparts, unless overwritten by command line options
	foreach i {
			iconify iconname iconbitmap iconmask iconposition
			geom database glimpsestrays
		} {
		if {![info exists manx($i)]} {set manx($i) $man($i)}
	}
}


# check for MANPATH in various places
# set manx(MANPATH0), maybe add to warnings

proc manManpathSet {} {
	global manx env

	# if user has MANPATH set, use it
	if {![info exists env(MANPATH)] || $env(MANPATH)==""} {
		set manpath ""; set manpathsrc ""; set def [string trim $manx(manpathdef)]

		# using GNU's gmanpath?
		if ![catch {set gmanpath [exec gmanpath -q]}] {
			set manpathsrc "given by gmanpath"
			set manpath $gmanpath


		# locations of man pages stored in "man.conf"?
		} elseif [file readable [set manconf "/etc/man.conf"]] {
			set manpathsrc "read from $manconf"

			set fid [open $manconf]
			while {![eof $fid]} {
				gets $fid line
				if {[regexp "^_default\[ \t\]+(.*)" $line all dirs]} {
					foreach dir $dirs { append manpath "$dir:" }
				}
			}
			close $fid


		# set to Makefile's default setting
		} elseif {$def!=""} {
			set manpathsrc "set to local default"
			set manpath $def


		# on an SGI, go with its default
		} elseif {[file readable /usr/catman] || [file readable /usr/share/catman]} {
			set manpathsrc "set to the IRIX default"
			set manpath "/usr/share/catman:/usr/share/man:/usr/catman:/usr/man"


		# calculate MANPATH from PATH
		} elseif {[info exists env(PATH)] && $env(PATH)!=""} {
			set manpathsrc "calculated from your PATH"

			foreach i [split $env(PATH) ":"] {
				if {$i==""} continue
				if [regexp {(.*)/bin(/.*)?} $i all dirtop] {
					set i $dirtop/man
					if {[manPathCheckDir $i]==""} {
						append manpath "$i:"
					}
				}
			}


		# otherwise set MANPATH to hardcoded default (your sixth and final chance!)
		} else {
			set manpathsrc "set from the hardcoded default"
			set manpath "/usr/local/man:/usr/man"
		}


		# all alternative settings finally set MANPATH here
		set manpath [string trim $manpath ":"]
		set env(MANPATH) $manpath

		regsub -all ":" $manpath ":\n    " manpathshow
		append manx(warnings) "You don't have a MANPATH environment variable set, but you should.\n"
		append manx(warnings) "Assuming a MANPATH, $manpathsrc, of:\n    $manpathshow\n\n"
	}

	set manx(MANPATH0) $env(MANPATH)
DEBUG {puts stderr "env(MANPATH) => $env(MANPATH)"}
}


# check validity of MANPATH and set manx(paths)

proc manManpathCheck {} {
	global man manx env

	set manx(paths) {}
	set manpatherr ""
	set whatiserr 0
	set glimpseerr 0

	# dumb BSDI concatenates all whatis information into single file
	set fBSDI [file readable "/usr/share/man/whatis.db"]
	# would like to generate validity information for it, but
	# if it does exist, then that's OK (it's BSDI) and if it
	# doesn't that's OK (it's got a good whatis organization)


	foreach i [split $env(MANPATH) ":"] {
		# not a general solution, but expand some abbreviations
		if {$i=="."} {set i [pwd]}
		if [string match "~*" $i] {set i [glob -nocomplain $i]}
		if {$i==""} continue

		if {[string match "*/" $i ]} {
			append manpatherr "$i -- spurious trailing slash character (\"/\")\n"
			# clean this one up and keep on going
			set i [string trimright $i "/"]
		}

		if {[lsearch $manx(paths) $i]>=0} {
			append manpatherr "$i -- duplicated path\n"
		} elseif {[set tmp [manPathCheckDir $i]]!=""} {
			append manpatherr $tmp
			if {[string match "*exist*" $tmp] && [file exists $i/man]} {
				append manpatherr "    but $i/man does, try it instead\n"
			}
		} elseif {![string match "*/catman" $i] && [glob -nocomplain $i/$manx(subdirs)]==""} {
			# if nothing in that directory, something's probably wrong
			append manpatherr "$i -- no subdirectories matching $manx(subdirs) glob pattern\n"
			# directory too specific: a subdirectory?
			if {![string match "*/man" $i] && [string match "*man" [file dirname $i]]} {
				append manpatherr "    => try changing $i to [file dirname $i]\n"
			}
		} else {
			# directory looks good, add it to list of valids
			lappend manx(paths) $i
			if {![info exists man($i)]} {set man($i) 1}
			lappend manx(pathstat) $man($i)

			# check for apropos index (called windex on Solaris)
			if {!$fBSDI && !([file exists $i/whatis] || [file exists $i/windex])} {
				append manpatherr "$i -- no `whatis' file for apropos\n"
				if {!$whatiserr} {
					append manpatherr "    => generate `whatis' with mkwhatis\n"
					set whatiserr 1
				}
			}

			# now check for Glimpse files
			if {$man(glimpse)!=""} {
				if {[glob -nocomplain $i/.glimpse*]==""} {
					append manpatherr "$i -- no Glimpse support\n"
					if {!$glimpseerr} {
						append manpatherr "    => try building Glimpse database (under Occasionals)\n"
						set glimpseerr 1
					}
				} elseif {![file readable $i/.glimpse_index]} {
					append manpatherr "$i -- Glimpse files exist but not readable\n"
				}
			}
		}
	}

	if {$manpatherr!=""} {
		append manx(warnings) "Problems in paths of MANPATH environment variable...\n" $manpatherr "\n"
	}
}

proc manPathCheckDir {dir} {
	set warning ""

	if {![file exists $dir]} {
		set warning "doesn't exist"
	} elseif {![file isdirectory $dir]} {
		set warning "not a directory"
	} elseif {![file readable $dir]} {
		set warning "not readable\n    => check permissions"
	} elseif {![file executable $dir]} {
		set warning "not searchable (executable)\n    => check permissions"
	} elseif {[glob -nocomplain $dir/*]==""} {
		set warning "is empty"
	}

	if {$warning!=""} {set warning "$dir -- $warning\n"}
	return $warning
}

proc manBinCheck {} {
	global man manx env

	set allpaths [expr {[info exists env(PATH)]?[split $env(PATH) ":"]:[list /usr/bin /usr/local/bin]}]

	# binaries checks for rman, sed, ...
	set err 0
	foreach var {manx(rman) man(sed) man(grep) man(format) man(apropos)
				man(zcat) man(compress) man(print) man(catprint)
				man(glimpse) man(glimpseindex)} {
		set val [set $var]
		if {$val==""} continue

		# first check for existence and executability...
		foreach pipe [split $val "|"] {
			set bin [lfirst $pipe]
			set found 0; set exe 0

#puts stderr "checking $var's $bin"
			if {[string match "/*" $bin]} {set pathlist [file dirname $bin]; set tail [file tail $bin]
			} else {set pathlist $allpaths; set tail $bin}

			foreach dir $pathlist {
				if {$dir=="."} continue
				set fullpath $dir/$tail
				if {[file isfile $fullpath]} {
					set found 1
					if {[file executable $fullpath]} {set exe 1}
					break
				}
			}
		}

		if {!$found} {
			puts stderr "$bin not found--check the $var variable in ~/.tkman or the Makefile."
			incr err
		} elseif {!$exe} {
			puts stderr "$bin found but not executable--check permissions."
			incr err
		} else {
			# ... then check for proper versions of selected executables
			if {[set index [lsearch -exact {rman glimpse glimpseindex} $tail]]!=-1} {
				set opt [lindex {"-v" "-V" "-V"} $index]
				set minvers [lindex {2.4 2.1 2.1} $index]

				set line ""; set vers unknown
				if [catch {set fid [open "|$fullpath $opt"]} info] {
					puts "ERROR executing \"$fullpath $opt\": $info\a"
					incr err
				} else {
					while {![eof $fid] && $line==""} {gets $fid line}
					catch {close $fid}

					# grok version number
					if {$line=="" || ![regexp {[0-9]+\.[0-9]+} $line vers] || $vers<$minvers} {
						puts stderr "$bin is version $vers--must be at least $minvers."
						incr err
					}
				}
			}
		}
	}
	if {$err} {exit 1}
}

proc manParseCommandline {} {
	global manx argv argv0 env

	for {set i 0} \$i<[llength $argv] {incr i} {
		set arg [lindex $argv $i]; set val [lindex $argv [expr $i+1]]
		switch -glob -- $arg {
			-M {set env(MANPATH) $val; incr i}
			-M+ {append env(MANPATH) ":$val"; incr i}
			-+M {set env(MANPATH) "$val:$env(MANPATH)"; incr i}
			-now {set manx(now) 1}
			--now {set manx(now) 0}
			-iconname {set manx(iconname) $val; incr i}
			-iconmask {set manx(iconmask) $val; incr i}
			-iconposition {set manx(iconposition) $val; incr i}
			-iconbitmap {set manx(iconbitmap) $val; incr i}
			-icon* {set manx(iconify) 1}
			--icon* {set manx(iconify) 0}
			-rebuild* {set manx(rebuildandquit) 1}
			-quit {if [string match no* $val] {set manx(quit) 0}; incr i}
			# put the more permissive option name patterns down below
			-v* {puts stdout "TkMan v$manx(version) of $manx(date)"; exit 0}
			-t* {set manx(title) $val; incr i}
			-s* {set manx(startup) $val; incr i}
			-database {set manx(database) $val; incr i}
			-d* {set manx(debug) 1; set manx(quit) 0; set manx(iconify) 0}
			--d* {set manx(debug) 0}
			-* {puts stdout "[file tail $argv0]: unrecognized option: $arg"; exit 1}
			default {
				after 2000 manShowMan $arg {{}} .man
				# permit several???  add extras to History?
				break
			}
		}
	}
	# grr, special case
	if {[info exists geometry]} {set manx(geom) $val}
}


proc DEBUG {args} {
	global manx
	if $manx(debug) {uplevel 1 eval $args}
}


##################################################
###
### start up
###
##################################################

### environment checks
if {[info tclversion]<7.4 || $tk_version<4.0} {
	puts stderr "Tcl 7.4/Tk 4.0 minimum versions required"
	puts stderr "You have Tcl [info tclversion]/Tk $tk_version"
	exit 1
} elseif {[info tclversion]>=8.0 || $tk_version>=5.0} {
	puts stderr "New major versions of Tcl and/or Tk may have introduced\nincompatibilies in TkMan.\nCheck the home ftp site for a new version.\n"
}


#--------------------------------------------------
#
# set defaults for shared global variables
#
#--------------------------------------------------

# # # # # # # # # # # # # # # # # # # # # # # # # #
# DON'T EDIT THE DEFAULTS HERE--DO IT IN ~/.tkman #
# # # # # # # # # # # # # # # # # # # # # # # # # #

# man() = persistent variables
# manx() = x-pire, system use, command line overrides

set w .man

#
# man
#

set man(manList) {1 2 3 4 5 6 7 8 9 l o n p}
set man(manTitleList) {
	"User Commands" "System Calls" Subroutines
	Devices "File Formats"
	Games "Miscellaneous" "System Administration" ?
	Local Old New Public
}

set man(families) {Times "New Century Schoolbook" Lucida Courier Helvetica}
set manx(styles) {normal bold italics bold-italics}
set manx(pts) {10 12 14 18 24}
set manx(sizes) {small medium large}
set man(gui-family) "Times"
set man(gui-style) "bold"
set man(gui-points) "medium"
set man(text-family) "New Century Schoolbook"
set man(text-style) "normal"
set man(text-points) "medium"
set man(vol-family) "Times"
set man(vol-style) "normal"
set man(vol-points) "medium"
set man(dpi) [lfirst $man(dpis)]
# try to determine if screen is 75dpi or 100dpi
if {$man(dpis)=={* 75 100}} {
    button .x
	if {[winfo fpixels . 1i]<100 && [set man(dpi) 75] && ![catch {.x configure -font [spec2font]}]} {
    } elseif {[set man(dpi) 100] && ![catch {.x configure -font [spec2font]}]} {
	} else {set man(dpi) *}
	destroy .x
}
set man(currentfont) [spec2font $man(text-family) $man(text-style) $man(text-points)]

set manx(tags) {h1 h2 h3 tt sc y b bi i search isearch manref title highlight hot indent indent2}
set man(tt) mono
set man(sc) s
set man(y) symbol
set man(b) bold
set man(bi) bold-italics
set man(i) italics
set man(h1) {bold l}
set man(h2) {bold m}
set man(h3) italics
set man(isearch) {-background gray}
set man(search) reverse
set man(manref) {mono -foreground blue}
set man(title) {bold large l}
set man(hot) {-underline yes}
set man(highlight) {-background #ffd8ffffb332}; # a pale yellow
set man(indent) {-lmargin1 5m -lmargin2 10m}
set man(indent2) {-lmargin1 10m -lmargin2 15m}

set man(maxhistory) 15; set manx(maxhistory-v) [set manx(maxhistory-t) {5 10 15 20 30 40 50}]
set man(recentdays) 14; set manx(recentdays-v) [set manx(recentdays-t) {1 2 7 14 30 60 90 180}]
set man(shortcuts) {}
set man(maxglimpse) 200; set manx(maxglimpse-v) [set manx(maxglimpse-t) {25 50 100 200 500 1000 "none"}]
set man(whatwhere) 1; set manx(whatwhere-v) {1 0}; set manx(whatwhere-t) {"pathname" "description"}
set man(iconify) 0; set manx(iconify-v) {1 0}; set manx(iconify-t) {"yes" "no"}
set man(subsect) ""; set manx(subsect-v) {"-b" ""}; set manx(subsect-t) {"yes" "no"}
set man(nroffsave) "off"; set manx(nroffsave-v) [set manx(nroffsave-t) {"off" "on" "on & compress"}]
set man(headfoot) "-k"; set manx(headfoot-v) {"-k" ""}; set manx(headfoot-t) {"yes" "no"}
set man(incr,case) -1
set man(regexp,case) -1
set man(aproposfilter) {| sort | uniq}
set man(scrollbarside) right; set manx(scrollbarside-v) [set manx(scrollbarside-t) {"left" "right"}]
set man(zaphy) ""; set manx(zaphy-v) {"-y" ""}; set manx(zaphy-t) {"yes" "no"}
set man(updateicon) 0; set manx(updateicon-v) {1 0}; set manx(updateicon-t) {"yes" "no"}
set man(strictmotif) 0; set manx(strictmotif-v) {1 0}; set manx(strictmotif-t) {"yes" "no"}
set man(subvols) 1; set manx(subvols-v) {1 0}; set manx(subvols-t) {"yes" "no"}
set man(textboxmargin) 5; set manx(textboxmargin-v) [set manx(textboxmargin-t) {0 1 2 3 4 5 7 10}]
set man(volcol) 4.0c; set manx(volcol-v) {0 1.5c 2.0c 2.5c 3.0c 3.5c 4.0c 4.5c 5.0c 7.5c 10.0c}; set manx(volcol-t) {"no columns" "1.5 cm" "2 cm" "2.5 cm/~1 inch" "3 cm" "3.5 cm" "4 cm" "4.5 cm" "5.0 cm/~2 inches" "7.5 cm" "10 cm"}
set man(apropostab) "4.5c"; set manx(apropostab-v) {0 3.0c 4.0c 4.5c 5.0c 5.5c 6.0c 7.5c 10.0c}; set manx(apropostab-t) {"none" "3 cm" "4 cm" "4.5 cm" "5 cm" "5.5 cm" "6 cm" "7.5 cm" "10 cm"}
set man(changeleft) "-c"
set man(tables) ""; set manx(tables-v) {"-T" ""}; set manx(tables-t) {"on" "off"}
#set man(zregexp) {\.(gz|z|Z)$} -- set in Makefile
#set man(zglob) {{gz,z,Z}} -- set in Makefile
set man(high,hcontext) 35
set man(high,vcontext) 10; set manx(high,vcontext-v) [set manx(high,vcontext-t) {0 2 5 7 10 15 20}]
set man(geom) 570x800+150+10
set man(geom-prefs) +300+300
set man(iconname) "TkMan"
#set man(iconbitmap) "" -- moved to Makefile
set man(iconmask) ""
set man(iconposition) ""
#set man(database) $env(HOME)/.tkmandatabase -- set in Makefile
set man(startup) $env(HOME)/.tkman
#set man(hypertext-binding) <Double-Button-1>

# colors
set man(colors) {black white red "light yellow" yellow orange green blue beige SlateGray4 gray75 gray90}

# set preferred colors
#set man(textfg) "black"
#set man(textbg) "white"
#set man(buttfg) [set man(activefg) [set man(guifg) "gray"]]
#set man(buttbg) [set man(guibg) "beige"]
#set man(activebg) #eed5b7

# colors are Tk's defaults
checkbutton .a
set man(textfg) [set man(buttfg) [set man(guifg)  [.a cget -foreground]]]
set man(textbg) [set man(guibg) [set man(buttbg) [.a cget -background]]]
set man(activefg) [.a cget -activeforeground]
set man(activebg) [.a cget -activebackground]
destroy .a

set manx(mono) [expr [winfo depth .]==1]
# [expr {[tk colormodel .]=="monochrome"}]
#set manx(mono) 1
if $manx(mono) {
	set man(foreground) "black"
	set man(background) "white"
	set man(colors) {black white}
	set man(textfg) [set man(activebg) [set man(buttfg) [set man(guifg) "black"]]]
	set man(textbg) [set man(activefg) [set man(buttbg) [set man(guibg) "white"]]]

	set man(search) [set man(isearch) "reverse"]
	set man(highlight) "bold-italics"
	set man(manref) "mono underline"

	# any more modifications for monochrome?
}


### collect all man's to this point as the defaults
# used for Defaults button in Preferences
# and to "comment out" unchanged parameters, so that subsequent
# changes (corrections), usually in the Makefile, propagate as expected
# (i.e., should make for fewer cases of "delete ~/.tkman")
# CAREFUL!  Only man()'s recorded here in defaults are saved to ~/.tkman
foreach i [array names man] {set default($i) $man($i)}


#
# man()-independent manx()
#

set manx(title) "TkMan v$manx(version)"
regexp "..../../.." {$Date: 1995/11/02 21:08:46 $} manx(date)
set manx(warnings) ""
set manx(manList) $man(manList)
set manx(manTitleList) $man(manTitleList)
set manx(userconfig) "### your additions go below"
set manx(posnregexp) {([-+]?[0-9]+)([-+][0-9]+)}
set manx(init) 0
set manx(manDot) 0
set manx(cursor) left_ptr
set manx(yview,help) 0
set manx(paths) ""
set manx(pathstat) ""
set manx(uid) 1
set manx(outcnt) 1
set manx(debug) 0
set manx(defaults) 0
set manx(startup) $man(startup)
set manx(savegeom) 1
# can't be sure volume 1 exists(!)
#set manx(lastvol$w) 1
set manx(lastman) TkMan
set manx(quit) 1
set manx(mandot) ""
set manx(db-manpath) ""
set manx(db-signature) ""
set manx(rebuildandquit) 0
set manx(now) 0
set manx(newmen) ""
set manx(xmono) {courier|helvetica}
set manx(subdirs) "{man,cat}*"
set manx(shift) 0

#source ~/spine/tkman/contrib/local-man.tcl
set high(*) "format: time, start/end pairs for use by text widget"

# TKMAN environment variable gives standard options
# env(TKMAN) goes first so options given on command-line override
if [info exists env(TKMAN)] {set argv "$env(TKMAN) $argv"}

# usually want to do this after startup file, but need to get -M here, before manx(startup) (?)
manParseCommandline


# execute some arbitrary Tcl code for new users (it may create a startup file)
if {![file exists $manx(startup)]} {eval $manx(newuser)}

# read in startup file after proc/vars/ui, so can modify them
set manx(savefilevers) "unknown"
set manx(updateinfo) ""
if {$manx(startup)!="" && [file readable $manx(startup)]} {
	set fid [open $manx(startup)]
	if [string match "#!*" [gets $fid line]] {
		puts stderr ".tkman (that's dot-tkman) looks like an executable"
		puts stderr "You should delete it, probably."
		exit 1
	}

	while {![eof $fid]} {
		if {[regexp {^# TkMan v([0-9.]+.*)} $line all manx(savefilevers)]} {
			break
		}
		gets $fid line
	}
	catch {close $fid}
DEBUG {puts "*** savefilevers = $manx(savefilevers)"}

	source $manx(startup)

	# update several variables from old save files
	#if {$manx(savefilevers)!=$manx(version)} {
	if {$manx(savefilevers)=="unknown" || [string range $manx(savefilevers) 0 2]<1.6} {
	#if {[string range $manx(savefilevers) 0 2]<[string range $manx(version) 0 2]} {
	#if {[string range $manx(savefilevers) 0 2]<1.6} {
		set manx(updateinfo) "Startup file information updated from version $manx(savefilevers) to version $manx(version).\n"

		### changes for < 1.6
		# update these variables
		foreach var {catsig compress zcat} {
#	 detailed list of changes more information than user wants
#			append manx(updateinfo) "    Changed man($var) from $man($var) to $default($var)\n"
			set man($var) $default($var)
		}

		# zap problem shifted sb keys
		foreach k {greater less question} {
			set var "sb(key,MS-$k)"
			if [info exists $var] {unset $var}
#			append manx(updateinfo) "    Deleted $k keybinding (use M-$k)\n"
		}

		# call manDot before user code
		append manx(updatedinfo) "    Added call to manDot\n"
		# (if no problem before, no problem now)

		# zap old man() variables ==> done every time save file updated
#		foreach v [array names man] {
#			if {![info exists default($v)] && ![string match "/*" $v]} {
#				append manx(updateinfo) "    Deleted obsolete variable man($v) (was set to $man($v))\n"; 
#				unset man($v)
#			}
#		}

		append manx(updateinfo) "Save updates via the Quit button or Occasionals/Checkpoint, or cancel updates via \"Occasionals / Quit, don't update\".\n"
		# backup old startup file
		if ![catch "exec $man(cp) $manx(startup) [set ofn $manx(startup)-$manx(savefilevers)]"] {
			append manx(updateinfo) "Old startup file saved as $ofn\n"
		}
		append manx(updateinfo) "\n\n"
	}
	if {!$manx(manDot)} {
		#puts stderr "no mandot" -- clean this up silently
		manDot
	}
}


# manx(highs) needs to get latest list of colors
set manx(highs) [concat $manx(styles) reverse underline mono $man(colors)]

set manx(extravols) [list {apropos "apropos list" "No apropos list"}]
if {$man(glimpse)!=""} { lappend manx(extravols) {glimpse "glimpse list" "No glimpse list"} }
lappend manx(extravols) {recent "Recently added/changed" {}} {high "All with Highlights" {}} {all "All Enabled Volumes" {}}
foreach i $manx(extravols) { lappend manx(specialvols) [lfirst $i] }


# do this after source of ~/.tkman has chance to change some of these
manBinCheck

# assertions

if {[llength $man(manList)]!=[llength $man(manTitleList)]} {
	puts stderr "Length of section abbreviations differs from length of section titles:\n\nlength [llength $man(manList)]:\t$man(manList)\n\nlength [llength $man(manTitleList)]:\t$man(manTitleList)"
	exit 1
}

# no sense to tease glimpseindex if can't write anything
set manx(glimpseindex) ""
if {$man(glimpse)!="" && $man(glimpseindex)!=""} {
	foreach p $manx(paths) {
		if {![file writable $p]} {set manx(glimpseindex) $man(glimpseindex); break}
	}
}


# almost always you'll want to make the cross product
#	 if you don't, be tricky and `set manx(defaults) 1'
if !$manx(defaults) manDescDefaults

# if no stray dirs for glimpse, don't glimpse there
if {[llength $mani($manx(glimpsestrays),dirs)]==0} {set manx(glimpsestrays) ""}

set STOP 0
TkMan

set starttime [time manInit]

DEBUG {
	puts stdout "init takes $starttime"

	# convenience variables
#	set w .man
	set t $w.show

	# debug box
	entry $w.in -relief sunken -textvariable manx(debugcmd)
	bind $w.in <KeyPress-Return> {winstdout .man.info "[eval $manx(debugcmd)]"}
	pack $w.in -fill x
}
